require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function block()
  doMotion("X+WorldGuard")
end

local function attack_tribazUpper(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = true
  end
  doMotion("U+Heruka")
end

local function attack_summonSelf(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
  end
  doMotion("D+Heruka")
end

local function attack_summon(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
  end
  doMotion("X+Heruka")
end

local function attack_divekick(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
  end
  doMotion("U+Attack")
end

local function attack_whipkick(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
  end
  doMotion("X+Attack")
end

local function HasSummon()
  local me = getMe()

  if me.Flag13 then 
    return true
  end
  return false
end

-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()

  -- Set origin
  param.origin = {
    x = me.XPos,
    y = me.YPos
  }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
  --
  param.time = 0
  -- Fake Low Health in the intro, then give it back with first summon.
  param.TriBazOK = false
  param.summonedTriBazOnce = false

  --
  param.defaultHealth = me.MaxLife
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do
  
  end

  while true do
    me, player = getMe(), getPlayer()
    --
    if aiDebug() then
      draw_bar(me.Flag13 and 1 or 0, 0, 2, 1, {255, 0, 255})
      draw_bar(me.LightR, 0, 3, 0, {255, 255, 0})
    end

    if tick_ok() then
      param.time = param.time + 1
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local me = getMe()
  local toReturn = DefaultOnBattleAttack(battleData)

  if aiDebug() then
    me.BattleSpeedMult = 1000
    trace("LightR - Summon Points: " .. me.LightR)
    trace("Flag13 - Baz Summoned?: " .. tostring(me.Flag13))
  end

  local dirChance = random(1000)
  local actionChance = random(1000)

  -- TriBaz OK Check -- 
  if true then -- me.HealthPct <= 0.8 and not param.TriBazOK then
    param.TriBazOK = true
  end

  -- TriBaz OK --
  if param.TriBazOK and param.summonedTriBazOnce then
    trace("TriBaz OK")
    if HasSummon() 
    then
      trace("Summon")
      -- we can choose to zap someone or go nuts with upper
      if actionChance > 500 and dirChance > 667  
      then
        attack_summon(toReturn)
      elseif actionChance > 500 
      then
        attack_tribazUpper(toReturn)
      elseif dirChance > 500
      then
        attack_divekick(toReturn)  
      else
        attack_whipkick(toReturn)
      end
    else 
      trace("Normal")
      if actionChance > 650
      then
        attack_summonSelf(toReturn)
      elseif dirChance > 500
      then
        attack_divekick(toReturn)  
      else
        attack_whipkick(toReturn)
      end
    end
  -- Attempt a TriBaz! --
  elseif param.TriBazOK and not param.summonedTriBazOnce 
  then
    trace("TriBaz First Summon")
    attack_summonSelf(toReturn)

    param.summonedTriBazOnce = true
  -- Regular Attacks --
  else
    trace("Regular Attacks")
    if actionChance > 500
    then
      --trace("SummonSelf")
      attack_summonSelf(toReturn)
    elseif dirChance > 500
    then
      --trace("Divekick")
      attack_divekick(toReturn)  
    else
      --trace("Whip Kick")
      attack_whipkick(toReturn)
    end
  end

  return toReturn
end --OnBattleAttack()