require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

-- Attacks --
local function attack_attack(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
end

local function attack_super(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = true
  end
  doMotion("X+Heruka")
end

-- sequence keys
local sequence = {
  default = 0
}

-- the initialization function for this AI
function OnInit()
  param.time = 0
  --
  param.battleSeq = 0  
  param.battleSubSeq = 0
  param.battleMaxTimeout = 60 * 5 -- just in case
  param.battleTimeout = 60 * 1 -- default for our own sequence
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  while true do
    me, player = getMe(), getPlayer()

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()

  param.battleSeq = 1
  param.battleSubSeq = 0 
  param.time = 0

  -- clear motions
  toReturn.meterBurn = false
  toReturn.pressAction = false
  toReturn.pressDash = false

  -- regular stuff
  attack_attack(toReturn)
  param.battleSeq = sequence.default

  return toReturn
end --OnBattleAttack()

function OnBattleTurnUpdate(battleData)
  local me = getMe()
  
  -- the loop --
  if param.time <= param.battleMaxTimeout
  then
    -- Default --
    if param.battleSeq == sequence.default
    then
      if param.time >= param.battleTimeout
      then
        debugPalette("Debug_Black")
      elseif param.battleSubSeq == 0 
      then
        debugPalette("Debug_LightBlue")
      else
        debugPalette("Debug_DarkBlue")
        addInput(dirs.N)
      end
    end
  end
  
  -- update only if not hitstop
  if update_ok()
  then
    param.time = param.time + 1
  end
end