require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function vec_dist_player(target)
  local me, player = getMe(), (target or getPlayer())
  -- 
  local vec_me = { x = me.XPos, y = me.YPos }
  local vec_pl = { x = player.XPos, y = player.YPos }

  return vec_dist( vec_me, vec_pl)
end

local function dist_origin()
  local me = getMe()
  -- 
  local vec_me = { x = me.XPos, y = me.YPos }
  local vec_pt = { x = param.origin.x, y = param.origin.y }

  return vec_dist( vec_me, vec_pt)
end

local function sight_attackRange(target)
  local me, player = getMe(), (target or getPlayer())
  local dx, dy = dist_sprite(target)

  if math.abs( dx ) <= param.attackRangeX
  and dy <= param.attackRangeY.top
  and dy >= param.attackRangeY.bottom then
      return true
  end
  return false
end

local function attack_dive(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = true
  end
  doMotion("U+Heruka")
  param.attackCooldown = 28
end

local function attack_flybyHit(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
  end
  doMotion("X+Heruka")
  param.attackCooldown = 28
end

local function attack_flybyGrab(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
  end
  doMotion("U+Attack")
  param.attackCooldown = 44
end

local function attack_squawk(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 28
end

local function falconFlockSeekOK()
  local me = getMe()

  local _dead = getProgression("NM_Falcon_Leader_Died")
  local _limit = getProgression("NM_Falcon_Health") <= 10

  if _limit then
    return true 
  else
    return false
  end

  return false
end

-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()
  
  -- Set origin
  param.origin = { x = me.XPos, y = me.YPos }

  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end

  param.lastHitPoint = { x = param.origin.x, y = param.origin.y }
  param.goalPoint = { x = param.origin.x, y = param.origin.y }
  --
  param.time = 0
  param.attackCooldown = 0
  --
  param.searchingForPlayer = false
  --
  param.sightRange = 160 * 6.5
  param.attackRangeX = 160 * 3.5
  param.attackRangeY = { top = 160 * 2.5, bottom = 160 * -1.5 }
  --            
  param.speeds = { min = 8, max = 17, range = 160 }

  --
  param.isNMFalcon = false
  if has_spawn_command("WaitForBattle")
  or me.WeaponType == hash("Notorious_Minion")
  then
    param.isNMFalcon = true
  end
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()
  
  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do
    
  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()

    if update_ok()
    then
      -- NOTORIOUS CROW HOMEBOY --
      if param.isNMFalcon
      then
        if not me:hasTag("WaitForBattle")
        and false
        then
          debugPalette("Debug_Blue")
          
          local playerDist = dist_sprite(player)
          
          if playerDist >= 160 * 0.125
          and falconFlockSeekOK()
          then
            local speeds = {
              min = 40,
              max = 320,
              range = 160 * 4
            }
            fly_to(player.XPos, player.YPos)
          end
        else
          debugPalette("Debug_Orange")
        end
      end
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
    local toReturn = DefaultOnBattleAttack(battleData)
    local me = getMe()

    local dirChance = random(1000)
    local actionChance = random(1000)

    if actionChance > 500
    then
      attack_dive(toReturn)
    elseif dirChance > 500
    then
      attack_squawk(toReturn)
    else
      attack_flybyHit(toReturn)
    end

    return toReturn
end --OnBattleAttack()