require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

local function attack_nm_flame_grab(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 24
end

local function attack_nm_flame_flamethrower(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 24
end

local function attack_icicledrop(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 24
end

local function attack_3HitCombo_notorious(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.meterBurn = false
  end
  doMotion("X+Heruka")
  param.attackCooldown = 24
end

local function attack_3HitCombo(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.meterBurn = false
  end
  doMotion("X+Heruka")
  param.attackCooldown = 24
end

local function attack_projectilePunch(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.meterBurn = false
  end
  doMotion("X+Heruka")
  param.attackCooldown = 32
end

local function attack_hug(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
  param.attackCooldown = 32
end

local function attack_eatRush(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 32
end

local function dist_origin()
  local me = getMe()
  local dx = param.origin.x - me.XPos
  local dy = param.origin.y - me.YPos
  return dx, dy 
end

local function isInSightRange(target)
  local me, player = getMe(), (target or getPlayer())
  local dx, dy = dist_sprite(target)
  
  local w = param.sightRangeX
  local h = param.sightRangeY
  if param.bossBurstedMode then
    w = param.sightRangeRageX
    h = param.sightRangeRageY
  end
  
  if dx >= -w/2
  and dx <= w/2
  and dy <= h.top
  and dy >= h.bottom
  then
    return true
  end
  return false
end

local function isInAttackRange(target)
  local me, player = getMe(), (target or getPlayer())
  local dx, dy = dist_sprite(target)

  local w = param.attackRangeX
  local h = param.attackRangeY
  if param.bossBurstedMode then
    w = param.attackRangeRageX
    h = param.attackRangeRageY
  end
  
  if dx >= -w/2
  and dx <= w/2
  and dy <= h.top
  and dy >= h.bottom
  then
    return true
  end
  return false
end

local function isInGrabRange(target)
  local me, player = getMe(), (target or getPlayer())

  local dx, dy = dist_sprite(target)

  if dx >= -param.grabRangeX/2
  and dx <= param.grabRangeX/2
  and dy <= param.attackRangeY.top
  and dy >= param.attackRangeY.bottom
  then
    return true
  end
  return false
end

local function AttackOK()
  if param.attackCooldown <= 0
  and canAttack(me)
  then
    return true
  end
  return false
end

local function eatGrabOK()
  local me = getMe()

  if me.ColorNum >= 4
  then
    return true
  else
    return false
  end

  return false
end

-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()
  --
  local players = getPlayers()
  -- Set origin
  param.time = 0
  param.turnWaitTime = 0
  param.attackCooldown = 0 
  --
  param.origin = { x = 0, y = 0 }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
  --
  param.alwaysHug = false 
  if has_spawn_command("AlwaysHug") then 
    param.alwaysHug = true 
  end
  --
  param.roamRangeX = 160 * 7.5
  param.roamRangeFudgeDist = 40
  param.sightRangeX = 160 * 10
  param.sightRangeY = { top = 160 * 2, bottom = 160 * -1.5 }
  param.attackRangeX = 160 * 4
  param.attackRangeCloseX = 160 * 2
  param.attackRangeY = { top = 160 * 3, bottom = 160 * -1.5 }
  --
  param.grabRangeX = 160 * 3
  --
  param.sightRangeRageX = 160 * 20
  param.sightRangeRageY = { top = 160 * 4, bottom = 160 * -1.5 }
  param.attackRangeRageX = 160 * 8
  param.attackRangeRageY = { top = 160 * 3, bottom = 160 * -1.5 }

  -- Do this at the end
  param.goalX = param.origin.x
  param.goalX = param.goalX + ((param.roamRangeX/2) * (me.FacingDir * -1))

  param.isNotorious = false
  if me.ColorNum == 4
  or (me.ColorNum >= 13 and me.ColorNum <= 15)
  then
    param.isNotorious = true 
  end

  param.isMagma = false
  if me.ColorNum == 13 
  then
    param.isMagma = true
  end

  param.isSnow = false
  if me.ColorNum == 14 
  then
    param.isSnow = true
  end

  param.bossBurstedMode = false  
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()
  

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do
  
  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
    if aiDebug() then
      draw_bar(param.attackCooldown, 0, 60)
    end

    ----------------------------------------------------------------------------
    -- The start
    ----------------------------------------------------------------------------
    -- co-op 
    if bossBursted() 
    then
      param.turnWaitTime = 0
      param.perchWaitTime = 0 
      param.moveDecay = 0 
      param.attackCooldown = 0 
      --
      param.bossBurstedMode = true
      me.InvinFlashTime = 60 * 3 
    end

    if param.bossBurstedMode 
    and me.InvinFlashTime <= 0
    then
      param.bossBurstedMode = false
    end
    
    debugPalette()
    if not isTangled(me) then
      debugPalette("Debug_Green")
      --------------------------------------------------------------------------
      -- Ticks
      --------------------------------------------------------------------------
      if not isInSightRange(target) then
        param.turnWaitTime = math.max(0, param.turnWaitTime - 1)
      end

      if not me:hasTag("Attack") then
        param.attackCooldown = math.max(0, param.attackCooldown - 1)
      end
      --
      local dist_goalPoint = dist_point(param.goalX, me.YPos)
      if math.abs( dist_goalPoint ) <= me.WorldCollisionWidth/2 then
        local side = param.origin.x - me.XPos
        if side >= 0 then side = 1 else side = -1 end 
        param.goalX = param.origin.x + (param.roamRangeX/2 * (side))
        param.turnWaitTime = 180
      end
      -- I see you!
      if isInSightRange(target)
      and ( param.bossBurstedMode or sprite_vulnerable(target) )
      then
        debugPalette("Debug_Yellow")
        -- Move to Player
        approach_withTurn(target.XPos, 8)
        -- Attack
        if isInAttackRange(target)
        and AttackOK()
        and not me:hasTag("Attack")
        then
          debugPalette("Debug_Red")
          --
          local r = random(1000)
          if dist_sprite(target) > 0
          and dist_sprite(target) <= param.attackRangeCloseX then
            attack_hug()
            me:setEnemyLeaderTo(target)
            if param.bossBurstedMode then
              attack_eatRush()
            end
          else
            attack_3HitCombo()
            me:setEnemyLeaderTo(target)
          end
        end
      elseif param.turnWaitTime > 0 then
        debugPalette("Debug_Blue")
        -- we're just waitin'
        if param.turnWaitTime == 90 then
          turn_around(8)
        end
      else
        debugPalette("Debug_Cyan")
        approach_withTurn(param.goalX, 8)
      end
    else
      debugPalette("Debug_Blink")
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()

  -- 50% chance of Attack 1 or 2 
  local dirChance = random(1000)
  local actionChance = random(1000)

  -- Notorious
  if param.isNotorious
  then
    if actionChance > 500
    then
      if param.isMagma
      then
        attack_nm_flame_grab(toReturn)
      else
        attack_icicledrop(toReturn)
      end
    elseif dirChance > 500
    then
      if param.isMagma
      then
        attack_nm_flame_flamethrower(toReturn)
      else
        attack_3HitCombo_notorious(toReturn)
      end
    else
      attack_3HitCombo_notorious(toReturn)
    end
  -- Regular Behavior
  else
    if dirChance > 500
    then
      attack_projectilePunch(toReturn)
    else
      attack_3HitCombo(toReturn)
    end

    if actionChance > 667 
    then
      attack_hug(toReturn)
    elseif actionChance <= 334
    and eatGrabOK()
    then
      attack_eatRush(toReturn)
    end

    if param.alwaysHug then 
      attack_hug(toReturn) 
    end
  end

  if aiDebug()
  then
    attack_eatRush(toReturn)
  end
  
  return toReturn
end --OnBattleAttack()