require("LuaLib")
require("MonsterLib")

require("util")


-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()
end

-- the main update function for this AI
function OnUpdate()
  local attackCooldown = 0
  local roamingEdgeWait = 0

  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()

  local startPosX = me.XPos
  local everGlomped = false
  
  local bossBurstedMode = false

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
  
    -- OK we DO need some stinking variables!
    local timeToAttack = false
    local attackReady = false
    local inRange = false
    local playerDistX = target.XPos - me.XPos  -- in world space
    playerDistX = playerDistX * me.FacingDir  -- now in local space i.e. in front or behind me
    local playerDistY = target.YPos - me.YPos
    
    local ROAMING_RADIUS_X = 800  -- how wide of a roaming radius do we want
    local ROAMING_EXTRA_OK_DIST = 75  -- extra distance we can be outside our roaming area before it gets recalculated
    local originDistX = me.XPos - startPosX  -- positive if we moved left, negative if we moved right
    
    local NOTICE_MAX_X_DIST = 500
    local function MAX_X_DIST()
      local w = 500
      if bossBurstedMode then
        w = 160 * 14 -- huge 
      end
      return w
    end
    local NOTICE_BEHIND_X_DIST = -350
    local function BEHIND_X_DIST()
      local w = -350
      if bossBurstedMode then
        w = -160 * 9 -- huge 
      end
      return w
    end
    
    local WAIT_TIME = 142
    local TURN_FRAME = WAIT_TIME / 2
    
    --print("HG dist %d" % {playerDistX})
    -- co-op 
    if bossBursted() 
    then
      WAIT_TIME = 0
      --
      bossBurstedMode = true
      me.InvinFlashTime = 60 * 3 
    end

    if bossBurstedMode 
    and me.InvinFlashTime <= 0
    then
      bossBurstedMode = false
    end
  
    
    local noticedSempai = (playerDistX > -10 
    and playerDistX <= MAX_X_DIST()
    and playerDistY < 300 
    and playerDistY > -200
    and target.invinFlashTime <= 0
    and not target:hasTag("Hitstun"))
    
    local sempaiBehindMe = (playerDistX < -10 
    and playerDistX >= BEHIND_X_DIST()
    and playerDistY < 300 
    and playerDistY > -200
    and target.invinFlashTime <= 0
    and not target:hasTag("Hitstun"))
    
    local sempaiHuggable = (playerDistX < 230 
    and playerDistX > 0 
    and playerDistY < 300 
    and playerDistY > -100 
    and target.invinFlashTime <= 0 
    and target.inBattle == 0 
    and not target:hasTag("Hitstun"))
    
    local sempaiGlompable = (playerDistX < 375 
    and playerDistX > -375
    and playerDistY < 500 
    and playerDistY > -100 
    and (bossBurstedMode or target.invinFlashTime <= 0) 
    and target.inBattle == 0
    and not everGlomped
    and me.Lifebar > 0 
    and me.SpawnCommand == hash("ForceBattle") -- yep!
    and not target:hasTag("Hitstun")
    and not target:hasTag("AjnaSlide"))
    
    
    -- count down cooldown
    attackCooldown = math.max(attackCooldown - 1, 0)
    
    if(sempaiGlompable and not everGlomped) then
      everGlomped = true
      me:startBattle(player)
    end
    
    -- if attacking, chill
    if me:hasTag("Attack") then
      --print("attacking, dawg!")
      attackCooldown = attackCooldown + 1
      
      -- elseif in hitstun, chill
    elseif me:hasTag("Hitstun") then
      --print("OUCH!!")
      
      -- elseif in the air, chill
    elseif not me.grd then
      --print("we're in the air, whoa")
      
      -- elseif in range to attack, attack them
    elseif sempaiHuggable then
      
      --if me.CeilingDist < 200 then  -- If we don't have enough head room for drill, spit instead
      --  doMotion("N+Atk")
      
      if attackCooldown <= 0 then
        local decideAttack = random(0,100)
        local leap_bonus = math.max(0, me.ColorNum - 3) * 15
        if ( playerDistY > 80 and decideAttack > (65 - leap_bonus )  and me.ColorNum >= 3) then
            doMotion("D+Atk")  -- Leap!
        elseif decideAttack > 50 then
          doMotion("U+Atk")  -- Bite!
        else
          doMotion("N+Atk")  -- Lick!
        end
        attackCooldown = 90
      end
        
    -- elseif in range to notice behind me, turn toward them
    elseif sempaiBehindMe then
      roamingEdgeWait = WAIT_TIME
      
      -- turn around
      addInput(dirs.B)
      wait()
      
    -- elseif in range to notice, walk at them
    elseif noticedSempai then
      --print("FREE HUGS")
      if me.ColorNum == 4 then
        wait()
      else
        addInput(dirs.F)
      end

    -- elseif turning, turn
    elseif me:hasTag("TurnStanding") then
      --print("For everything there is a season")
    
    -- else roam around
    else
    
      if me.ColorNum == 4 then
        wait()
      elseif me.ColorNum == 5 or me.ColorNum == 6 then
      
        if roamingEdgeWait <= 0 then
          addInput(dirs.B)
          roamingEdgeWait = WAIT_TIME
        else
          roamingEdgeWait = roamingEdgeWait - 1
        end
      else
      
      
        -- check to see if I am outside the roaming area, and move it if so
        if originDistX > ROAMING_RADIUS_X + ROAMING_EXTRA_OK_DIST then
          --print("REcalc right")
          startPosX = startPosX + (originDistX - ROAMING_RADIUS_X)
        elseif originDistX < -1 * (ROAMING_RADIUS_X + ROAMING_EXTRA_OK_DIST) then
          --print("REcalc left")
          startPosX = startPosX + (originDistX + ROAMING_RADIUS_X)
        end
      
      
        local atRightEdge = (originDistX >= ROAMING_RADIUS_X)
        local atLeftEdge = (originDistX <= (ROAMING_RADIUS_X * -1))
        
        
        if (me.FloorInfo > 1 or me.WallDistAhead <= 50) and not noticedSempai then
          -- if facing toward the start position, then this is the new opposite edge and the start pos goes behind us
          if originDistX > 0 and me.FacingDir < 0 then
            --print("New thing right")
            startPosX = me.XPos + ROAMING_RADIUS_X
          elseif originDistX < 0 and me.FacingDir > 0 then
            --print("New thing left")
            startPosX = me.XPos - ROAMING_RADIUS_X
          end
          -- and we turn around, regardless
          --print("Waiting for idle to turn")
          waitForIdle()
          --print ("Turning maybe")
          addInput(dirs.B)
          wait()
          
        elseif atRightEdge
               and me.FacingDir > 0  -- facing away from the start
               and roamingEdgeWait <= 0 then
            --print("Right edge wait")
          roamingEdgeWait = WAIT_TIME
        elseif atLeftEdge
               and me.FacingDir < 0  -- facing away from the start
               and roamingEdgeWait <= 0 then
            --print("Left edge wait")
          roamingEdgeWait = WAIT_TIME
        elseif roamingEdgeWait > 0 then
          roamingEdgeWait = roamingEdgeWait - 1
          if roamingEdgeWait < TURN_FRAME then
            if atRightEdge and me.FacingDir > 0 then
              addInput(dirs.B)
            elseif atLeftEdge and me.FacingDir < 0 then
              addInput(dirs.B)
            end
          end
        else
          addInput(dirs.F)
    roamingEdgeWait = 0
        end
      
      
      end -- check for palette number
      
    end -- main if/elseif/else
    
    wait()
      
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
    local toReturn = DefaultOnBattleAttack(battleData)
    local me = getMe()
    return toReturn
end -- OnBattleAttack()