require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

local me, player = nil
local param = {
  origin = { x = 0, y = 0 },
  time = 0,
  --
  sightRangeX = 160 * 9,
  sightRangeY = { top = 160 * 1.5, bottom = 160 * -1 },
  attackRangeX = 160 * 6,
  attackRangeY = { top = 160 * 2.5, bottom = 160 * -1.5 },
}

local function dist_origin()
  local me = getMe()
  local dx = param.origin.x - me.XPos
  local dy = param.origin.y - me.YPos
  return dx, dy 
end

local function attack_atk(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
end

-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  me, player = getMe(), getPlayer()
  local players = getPlayers()
  -- Set origin
  param.time = 0
  param.attackCooldown = 0 

  param.isShadowBoss = false
  if has_spawn_command("ShadowBoss")
  then
    param.isShadowBoss = true
  end

  --
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
end

-- the main update function for this AI
function OnUpdate()
  while true do
    me, player = getMe(), getPlayer()

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()
  
  attack_atk(toReturn)

  if param.isShadowBoss
  then
    attack_atk(toReturn)
  end

  return toReturn
end --OnBattleAttack()