require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function dist_origin()
  local me = getMe()
  local dx = param.origin.x - me.XPos
  local dy = param.origin.y - me.YPos
  return dx, dy 
end

local function isInSightRange(_spr)
  local me = getMe()
  local spr = _spr or getPlayer()
  
  local w = param.sightRangeX
  local h = param.sightRangeY
  if param.bossBurstedMode then
    w = param.sightRangeRageX
    h = param.sightRangeRageY
  end
  
  if isInRange(spr, me.XPos, me.YPos, w, h)
  then
    return true
  end
  return false
end

local function isInAttackRange(_spr)
  local me = getMe()
  local spr = _spr or getPlayer()
  
  local w = param.attackRangeX
  local h = param.attackRangeY
  if param.bossBurstedMode then
    w = param.attackRangeRageX
    h = param.attackRangeRageY
  end
  
  if isInRange(spr, me.XPos, me.YPos, w, h)
  then
    return true
  end
  return false
end

local function attack_prance(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
end

local function attack_tailStab(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("U+Attack")
  param.attackCooldown = 50
end

local function attack_bowShot(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
end

local function attack_buzzSaw(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Heruka")
end

-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()

  -- Set origin
  param.time = 0
  param.attackCooldown = 0 
  param.origin = { x = me.XPos, y = me.YPos }

  --
  if me:getSpawnpointPos() ~= nil then
      param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
  --
  param.sightRangeX = 160 * 18
  param.sightRangeY = 160 * 15
  --param.sightRangeY = { top = 160 * 1.5, bottom = 160 * -1 }
  param.attackRangeX = 160 * 13
  param.attackRangeY = 160 * 9
  --param.attackRangeY = { top = 160 * 2.5, bottom = 160 * -1.5 }
  --
  param.sightRangeRageX = 160 * 26
  param.sightRangeRageY = 160 * 19
  param.attackRangeRageX = 160 * 13
  param.attackRangeRageY = 160 * 13
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()
  
  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
    if tick_ok() then
      if not me:hasTag("Attack") then
        param.attackCooldown = math.max(0, param.attackCooldown - 1)
      end
      param.time = param.time + 1
    end
        
    -- co-op 
    if bossBursted() 
    then
      param.attackCooldown = 32
      --
      param.bossBurstedMode = true
      me.InvinFlashTime = 60 * 5
    end

    if param.bossBurstedMode 
    and me.InvinFlashTime <= 0
    then
      param.bossBurstedMode = false
    end
    
    if ( param.bossBurstedMode or sprite_vulnerable(target) ) then
      if param.attackCooldown <= 0
      and isInAttackRange(target)
      and dist_point(target.XPos, target.YPos) >= 0 
      then
        attack_tailStab()
      elseif isInSightRange(target)
      and dist_point(target.XPos, target.YPos) < 0 
      then
        turn_around(7)
      end
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()

  local dirChance = random(1000)
  local actionChance = random(1000)
  toReturn.meterBurn = false

  if actionChance > 600
  then
    attack_tailStab(toReturn)
    
    local isMeterBurn = true
    toReturn.meterBurn = isMeterBurn
  elseif dirChance > 500
  then
    attack_prance(toReturn)
  else
    attack_tailStab(toReturn)
    toReturn.meterBurn = false
  end

  return toReturn
end --OnBattleAttack()