require("LuaLib")

setInit(function()
  newOnInit()
  newRoutine = coroutine.create(newOnUpdate)
end)

setUpdate(function()
  if type(curRoutine) == "thread" then
    local loops = 0
    repeat
      local status = coroutine.status(curRoutine)
      local info = debug.traceback(curRoutine)
      
      if status == "dead" then
        print("An AI thread is Dead!  Oh no!  Restarting it...")
        curRoutine = coroutine.create(OnUpdate)
      end
      
      --if status == "suspended" and evaluate then
      --print("Suspended")
      local success, msg = coroutine.resume(curRoutine)
      if not success then
        print("Error AI: %s" % msg)
        print(debug.traceback(curRoutine))
        return
      end

      local status = coroutine.status(curRoutine)
      
      loops = loops + 1
      if loops > 5 then
        print("Potential Infinite Loop detected in AI. Breaking out!")
        break
      end
    until status ~= "dead"
  end
end)

-- returns a TABLE with the following possible elements:
-- dir -> dirs.N, dirs.D, or dirs.U
-- action = true or false (or nil) for pressing the Action button
--          in addition to the Attack button
-- meterburn = true or false (or nil) for pressing the MeterBurn button
-- and we'll keep
-- turnNum = our nice local variable for how many turns we've attacked so far
declare("DefaultOnBattleAttack", function(battleData)
    --print("An AI is battle-attacking!")
   
     if(battleData.turnNum == nil) then
       battleData.turnNum = 1    -- STARTING AT 1 NOT ZERO!
     else
       battleData.turnNum = battleData.turnNum + 1
     end

    local toReturn = {dir = dirs.N, pressAction = false, meterBurn = false}
   
    -- 33% chance of U/D/Neutral directions
    local dirChance = random(1000)

    if(dirChance < 333) then
        toReturn.dir = dirs.D
    elseif(dirChance > 667) then
        toReturn.dir = dirs.U
    end
    
    local actionChance = random(1000)

    if(actionChance < 333) then
      toReturn.pressAction = true
    end
    
    return toReturn
end)