-- We need LuaLib for declare
require("LuaLib")
require("debug_ext")

-- We use this for finding angles
require("vec2")
require("math_ext")

declare("turn_around", function(time)
    local me = getMe()
    local facing = me.FacingDir
    local time = time or 5
    addInput(dirs.B)
    wait(time)
    while facing == me.FacingDir do
        addInput(dirs.B)
        wait(time)
    end
end)

declare("approach", function(x)
    local me = getMe()
    local dist = x - me.XPos
    dist = dist * me.FacingDir

    if dist > 0 then 
        addInput(dirs.F)
    else
        addInput(dirs.B)
    end
end)

declare("approach_withTurn", function(x, time)
    local me = getMe()
    local dist = x - me.XPos
    dist = dist * me.FacingDir
    if dist > 0 then 
        addInput(dirs.F)
    else
        turn_around(time)
    end
end)

-- speeds is a table that lets you control how fast the character
-- approaches the point. It will not modify the slot otherwise
-- { min = 0, max = 0, range = n }
declare("fly_to", function(px, py, speeds)
    local me = getMe()

    local vT = { x = px, y = py }
    local vP = { x = me.XPos, y = me.YPos }

    local diff = { x = (vT.x - vP.x), y = (vT.y - vP.y) }
    diff.x = diff.x * me.FacingDir

    local angle = vec_angle(diff)

    -- We have bonus parameters to use.
    if speeds then
        local dist = vec_dist( vP, vT )
        local min = speeds.min or 20
        local max = speeds.max or 20
        local range = speeds.range or 1
        local scaled = scale(dist, 1, range, min, max)
        --
        me.Slot1 = clamp( scaled, min, max )
    end

    if inRange(angle, 22.5, 67.5) then addInput(dirs.UF) end -- UF
    if inRange(angle, -22.5, 22.5) then addInput(dirs.F) end -- F
    if inRange(angle, -67.5, -22.5) then addInput(dirs.DF) end --DF
    if inRange(angle, -112.5, -67.5) then addInput(dirs.D) end --D
    if inRange(angle, -157.5, -112.5) then addInput(dirs.DB) end --DB
    if inRange(angle, -202.5, -157.5)
    or inRange(angle, 157.5, 202.5) then addInput(dirs.B) end --B
    if inRange(angle, 112.5, 157.5) then addInput(dirs.UB) end --UB
    if inRange(angle, 67.5, 112.5) then addInput(dirs.U) end --U
end)

-- alias
declare("approach_point", function(px, py, speeds)
    return fly_to(px, py, speeds)
end)