-- We need LuaLib for declare
require("LuaLib")

declare("vec_pos", function(spr)
  if spr ~= nil
  then
    local vec = { x = 0 , y = 0 }
    vec.x = spr.XPos
    vec.y = spr.YPos

    return vec
  else
    return false
  end

  return false
end)

declare("vec2", function(spr)
  return vec_pos(spr)
end)

declare("vec_add", function(a, b)
  local v = { x = 0, y = 0 }
  
  v.x = a.x + b.x
  v.y = a.y + b.y

  return v
end)

declare("vec_sub", function(a, b)
  local v = { x = 0, y = 0 }
  
  v.x = a.x - b.x
  v.y = a.y - b.y

  return v
end)

declare("vec_mul", function(a, b)
  local v = { x = 0, y = 0 }
  
  v.x = a.x * b.x
  v.y = a.y * b.y

  return v
end)

declare("vec_len", function(v)
  return math.sqrt(v.x ^ 2 + v.y ^ 2)
end)

declare("vec_dist", function(a, b)
  local diff = { x = a.x - b.x, y = a.y - b.y }
  local result = math.sqrt((diff.x ^ 2 + diff.y ^ 2))
  return (result == result) and result or 0 
end)

declare("vec_norm", function(v)
  local len = vec_len(v)
  return { x = v.x / len, y = v.y / len}
end)

declare("vec_rot", function(v, deg)
  local r = math.rad(deg)
  local c, s = math.cos(r), math.sin(r)
  local rot = { x = v.x * c, y = v.y * s }

  return rot
end)

declare("vec_angle", function(v)
  return ( math.atan2(v.y, v.x) * (180  / math.pi))
end)

declare("vec_dot", function(a, b)
  local _v = { x = a.x * b.x, y = a.y * b.y }
  local _dot = _v.x + _v.y

  return _dot
end)

-- vec2 of an object in the level!
declare("vec_object", function(name, isVisual)
  if not name then 
    trace("We failed to get object " .. name)
    return nil 
  end
  local _x, _y, _z = getObjectPos(name, isVisual)
  if _x and _y and _z
  then
    return { x = _x, y = _y, z = _z }
  else
    trace("We failed to make a vec3 of " .. name)
  end
end)