require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function attack_smack(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 30
end


-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  local me, player = getMe(), getPlayer()
  --
  param.time = 0
  param.max_time = 30
  param.attackCooldown = 0 
  --
  param.sightRangeX = 160 * 7
  param.sightRangeY = { top = 160 * 1, bottom = 160 * -1 }
  param.attackRangeX = 160 * 3.5
  --
  param.turnOnLanding = false
end

local function isInSightRange(target)
  local me, player = getMe(), (target or getPlayer())

  local dx, dy = dist_sprite(target)

  if dx >= -param.sightRangeX/2
  and dx <= param.sightRangeX/2
  and dy <= param.sightRangeY.top
  and dy >= param.sightRangeY.bottom
  then
    return true
  end
  return false
end

local function isInAttackRange(target)
  local me, player = getMe(), (target or getPlayer())

  local dx, dy = dist_sprite(target)

  if dx >= -param.attackRangeX/2
  and dx <= param.attackRangeX/2
  and dy <= param.sightRangeY.top
  and dy >= param.sightRangeY.bottom
  then
    return true
  end
  return false
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
    if aiDebug() then
      --trace("Wallahead %i" % { me.WallDistAhead })
    end

    if param.time == 0 then
      param.max_time = 30 + random(30)
    end

    if has_spawn_command("RandomXVel") then
      me.XVel = random(-12, 12)
      me.SpawnCommand = 0
    end

    if tick_ok() then
      param.attackCooldown = math.max(0, param.attackCooldown - 1)
    end

    if tick_ok() then
      debugPalette()
      if isInAttackRange(target) 
      and sprite_vulnerable(target)
      and me.OnGround > 0
      then
        debugPalette("Debug_Red")
        attack_smack()
        param.turnOnLanding = true
        wait(7) -- Delay a tiny bit so we can track grounded and auto-turn
      elseif isInSightRange(target) then
        debugPalette("Debug_Blue")
        approach_withTurn(target.XPos, 6)
      elseif me.WallDistAhead <= 20 
      and me.OnGround > 0
      then
        -- Change direction
        addInput(dirs.B)
        wait(3)
        param.time = 0
        param.max_time = 30 + random(30)
      elseif me.OnGround > 0 then
        if param.turnOnLanding then
          if dist_sprite(target) < 0 then
            turn_around(7)
          end
          param.turnOnLanding = false
        end
        -- Interior Crocodile Alligator
        addInput(dirs.F)
      end
    else
      debugPalette("Blink_Fast")
    end
    wait() -- try to keep this at the end
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
    local toReturn = DefaultOnBattleAttack(battleData)
    local me = getMe()
    return toReturn
end --OnBattleAttack()