require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function block()
  doMotion("X+WorldGuard")
end

-- X+Atk+StateNum:!HasTag:"Attack"+LifePct>=1/8,VALID=3
local function attack_turretStrafe(data) -- 0 Cartridges
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  trace("turretStrafe")
end

local function attack_railgunAuto(data) -- 1 Cartridge
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
  trace("railgunAuto")
end

local function attack_railgunTriple(data) -- 1 Cartridge
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("U+Attack")
  trace("railgunTriple")
end

local function attack_railgunQuad(data) -- 2 Cartridges
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
  trace("railgunQuad")
end

local function attack_furnaceFire(data) -- 0 Cartridges
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Heruka")
  trace("furnaceFire")
end

local function attack_furnaceFire_Big(data) -- 1 Cartridge
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("U+Heruka")
  trace("furnaceFireBIG")
end

local function attack_summonUnit(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Heruka")
  trace("summonUnit")
end

local function attack_setToMiniboss(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = true
    data.meterBurn = false
  end
  doMotion("X+Dash")
  trace("become miniboss")
end

local function attack_heal(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = true
  end
  doMotion("X+Heruka+MeterBurn")
  trace("heal")
end

local function attack_cartridgeUp(data) -- +1 Cartridge
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Heruka")
  trace("cartridgeUP")
end

-- Return if Furnace NOT dead
local function isFurnaceOK()
  local me = getMe()

  if me.LightX >= 1
  then
    return true
  else
    return false
  end

  return false
end

-- Return how many ALIVE
local function isTurretOK()
  local me = getMe()

  if me.LightB >= 1
  then
    return true
  else
    return false
  end

  return false
end

local function getNumCharges()
  local me = getMe()

  return me.LightG, me.LightR
end

local function isHealOK()
  local me = getMe()

  if getNumCharges() >= 2
  and me.LifePct <= 0.7
  then
    return true
  else
    return false
  end


  return false
end

local function isSummonOK()
  local me = getMe()

  return getNumCharges() >= 1
end
-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  local me, player = getMe(), getPlayer()

  -- Set origin
  param.origin = { x = me.XPos, y = me.YPos }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end

  param.time = 0
  param.attackCooldown = 0

  param.attackRangeX = 160 * 18
  param.attackRangeY = 160 * 7
  param.sightRangeX = 160 * 30
  param.sightRangeY = 160 * 9

  param.battle_TurnsUntilSummonUnitsOK = 0

  if aiDebug()
  then
    me.BattleSpeedMult = 1000
  end
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    --
    if aiDebug() then
      draw_bar(param.attackCooldown, 0, 100)
    end

    if tick_ok() then
      if not me:hasTag("Attack") then
        param.attackCooldown = math.max(0, param.attackCooldown - 1)
      end
      --param.time = param.time + 1
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local me = getMe()
  local toReturn = DefaultOnBattleAttack(battleData)

  local dirChance = random(1000)
  local actionChance = random(1000)

  if actionChance > 900
  then
    if isHealOK()
    and dirChance > 500
    then
      trace("Action - Heal")
      attack_heal(toReturn)
    elseif isSummonOK()
    then
      trace("Action - Summon")
      attack_summonUnit(toReturn)
    end
  else
    if isTurretOK()
    then
      if dirChance > 667
      then
        trace("Turret - Railgun")
        attack_railgunAuto(toReturn)
      elseif dirChance < 337
      then
        trace("Turret - Strafe")
        attack_turretStrafe(toReturn)
      end
    else
      trace("Furnace Fire")
      attack_furnaceFire(toReturn)
    end
  end

  if aiDebug()
  then
    --attack_furnaceFire(toReturn)
    --attack_setToMiniboss(toReturn)
    --me.LightG = 1
    --me.LightB = 0
    --attack_furnaceFire(toReturn)
    --attack_railgunAuto(toReturn)
    --attack_heal(toReturn)
    --attack_turretStrafe(toReturn)
    --attack_summonUnit(toReturn)
    --[[
    if battleData.turnNum % 2 == 0
    then 
      attack_railgunAuto(toReturn)
    else
      attack_turretStrafe(toReturn)
    end
    ]]
    --me.BattleSpeedMult = 1000
  end

  return toReturn
end --OnBattleAttack()