require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

local function dist_origin()
  local me = getMe()
  local dx = param.origin.x - me.XPos
  local dy = param.origin.y - me.YPos
  return dx, dy 
end

local function isInSightRange(_spr)
  local me = getMe()
  local spr = _spr or getPlayer()
  if isInRange(spr, me.XPos, me.YPos, param.sightRangeX, param.sightRangeY)
  then
    return true
  end
  return false
end

local function isInAttackRange(_spr)
  local me = getMe()
  local spr = _spr or getPlayer()
  if isInRange(spr, me.XPos, me.YPos, param.attackRangeX, param.attackRangeY)
  then
    return true
  end
  return false
end

local function attack_slash(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.meterBurn = false
  end
  doMotion("X+Heruka")
end

local function attack_tusk(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("U+Attack")
end

local function attack_bite(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
  param.attackCooldown = 22
end

local function attack_magicBrain(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
end

local function debugStuff()
  draw_bar(param.attackCooldown, 0, 100)
end

-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()

  -- Set origin
  param.time = 0
  param.attackCooldown = 0 

  param.origin = { x = me.XPos, y = me.YPos }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end

  param.sightRangeX = 160 * 18
  param.sightRangeY = 160 * 15
  --param.sightRangeY = { top = 160 * 1.5, bottom = 160 * -1 }
  param.attackRangeX = 160 * 13
  param.attackRangeY = 160 * 9
  --param.attackRangeY = { top = 160 * 2.5, bottom = 160 * -1.5 }
  
  param.bossBurstedMode = false
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()
  
  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
    if aiDebug() then
      debugStuff()
    end

    if tick_ok() then
      if not me:hasTag("Attack") then
        param.attackCooldown = math.max(0, param.attackCooldown - 1)
      end
      param.time = param.time + 1
    end

    -- co-op 
    if bossBursted() 
    then
      param.attackCooldown = 20
      --
      param.bossBurstedMode = true
      me.InvinFlashTime = 60 * 3 
    end

    if param.bossBurstedMode 
    and me.InvinFlashTime <= 0
    then
      param.bossBurstedMode = false
    end

    if sprite_vulnerable(target) 
    or param.bossBurstedMode then
      if param.attackCooldown <= 0
      and isInAttackRange(target)
      and dist_point(target.XPos, target.YPos) >= 0 
      then
        attack_bite()
      elseif isInSightRange(target)
      and dist_point(target.XPos, target.YPos) < 0 
      then
        turn_around(7)
      end
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()
  
  local dirChance = random(1000)
  local actionChance = random(1000)

  attack_bite(toReturn)

  if actionChance > 500 then
    attack_slash(toReturn)
  end

  return toReturn
end --OnBattleAttack()