require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")


local function isInSightRange()
  local me, player = getMe(), getPlayer()

  if dist_player() >= -param.sightRangeX/2
  and dist_player() <= param.sightRangeX/2
  and select(2,dist_player()) <= param.sightRangeY.top
  and select(2,dist_player()) >= param.sightRangeY.bottom
  then
    return true
  end
  return false
end

--[[ Normal Attacks ]]
local function attack_conjure(data)
  if data ~= nil then
      data.dir = dirs.N
      data.pressAction = false
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("X+Attack")
end

local function attack_snap(data)
  if data ~= nil then
      data.dir = dirs.U
      data.pressAction = false
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("U+Attack")
end

local function attack_snapSword(data)
  if data ~= nil then
      data.dir = dirs.D
      data.pressAction = false
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("D+Attack")
end

--[[ Action Button ]]
local function attack_veenaPlay(data)
  if data ~= nil then
      data.dir = dirs.N
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("X+Heruka")
end

local function attack_flipKick(data)
  if data ~= nil then
      data.dir = dirs.U
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("U+Heruka")
end

local function attack_summonHeads(data)
  if data ~= nil then
      data.dir = dirs.N
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = true
  end
  doMotion("X+Heruka+MeterBurn")
end

local function attack_summonSnap_toTeleport(data)
  if data ~= nil then
      data.dir = dirs.D
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = true
  end
  doMotion("D+Heruka+MeterBurn")
end


--[[ Cinematics, Special Motions ]]
local function attack_summonSnap(data)
  if data ~= nil then
      data.dir = dirs.D
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("D+Heruka")
end

local function attack_teleport(data)
  local me = getMe()
  if data ~= nil then
      data.dir = dirs.U
      data.pressAction = false
      data.pressDash = true
      data.meterBurn = false
  end
  doMotion("U+Dash")
end

local function attack_teleportVeena(data)
  local me = getMe()
  if data ~= nil then
      data.dir = dirs.N
      data.pressAction = true
      data.pressDash = false
      data.meterBurn = false
  end
  doMotion("X+Attack")
end
-- the initialization function for this AI
function OnInit()
  local me, player = getMe(), getPlayer()

  param.time = 0
  param.phase = 1
  param.mode = 0
  param.rank = 0
  param.turnsSinceHeads = 0
  param.turnsSinceTeleport = 0 
  -- HP Limits in LifePct, NOT HEALTH values
  param.HPLimits = {
    [0] = 100/100,
    [1] = 2/3,
    [2] = 1/3,
    [3] = 1/100, -- I mean, honestly?
  }

  --
  param.origin = { x = 0, y = 0 }
  param.origin.x, param.origin.y = me.XPos, me.YPos
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
  
  param.sideline = { x = 0, y = 0 }
  if getObjectPos("Spawn_Boss_Ravannavar_Sideline") ~= nil then
    local _x, _y, _z = getObjectPos("Spawn_Boss_Ravannavar_Sideline")
    trace(_x .. " " .. _y .. " " .. _z)
    param.sideline.x, param.sideline.y = _x, _y
    trace( param.sideline.x .. " " .. param.sideline.y )
  end
  
  param.sightRangeX = 160 * 6
  param.sightRangeY = { top = 160 * 4, bottom = 160 * -2 }
  
  -- BATTLE -- 

  param.summonedHaathi = false
  param.summonedHeads = 0 
  param.teleportedOut = false
  param.startedBattle = false

  -- Do the dumb thing FIRST
  
  --me.LightY = param.origin.x
  --me.LightZ = param.origin.y
  --me.LightR = param.sideline.x
  --me.LightG = param.sideline.y
  
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    --
    if aiDebug() then
      debugPalette("Debug_Blink")
      draw_point(param.origin.x, param.origin.y)
      draw_point(param.sideline.x, param.sideline.y)
    end
    --
    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()
  local player = getPlayer()

  local dirChance = random(1000)
  local actionChance = random(1000)

  -- Reassign these values JUST IN CASE?
  me.LightY = param.origin.x
  me.LightZ = param.origin.y
  me.LightR = param.sideline.x
  me.LightG = param.sideline.y

  debugPalette()

  -- Attacks !!!!!!!!
  if param.phase == 0 then
    trace("We started at 0, what's GOING ON!")
    param.phase = 1
  elseif param.phase == 1 then
    debugPalette("Debug_Red")
    -- Only advance head tracking in this state
    param.turnsSinceHeads = param.turnsSinceHeads + 1
    -- move onto the next phase --
    if me.LifePct <= param.HPLimits[1]
    then
      trace("Moving onto the next Phase!")
      param.phase = 2
      -- Let's do the summon here too
      trace("P1 Teleport (To Exit)")
      attack_summonSnap_toTeleport(toReturn)
      --attack_teleport(toReturn)
      --
      param.summonedHaathi = true
    -- Scimitar!
    elseif param.turnsSinceHeads > 4
    then
      debugPalette("Debug_Orange")
      trace("P1 SnapSword")
      attack_snapSword(toReturn)
      param.turnsSinceHeads = 0
    -- Conjure
    elseif dirChance > 500
    then
      trace("P1 Conjure")
      attack_conjure(toReturn)
    -- Flashkick
    else
      trace("P1 Flashkick")
      attack_flipKick(toReturn)
    end
  elseif param.phase == 2 then
    debugPalette("Debug_Blue")
    --
    if me:hasTag("Teleport_Loop") then 
      param.turnsSinceTeleport = param.turnsSinceTeleport + 1
    end

    -- Summon Friends 
    if me:hasTag("Teleport_Loop")
    then
      attack_teleportVeena(toReturn)
    elseif param.summonedHeads <= 0 then
      param.summonedHeads = param.summonedHeads + 1
      attack_summonHeads(toReturn)
    -- Scimitar
    elseif param.turnsSinceHeads > 4
    then
      debugPalette("Debug_Orange")
      trace("P2 SnapSword")
      attack_snapSword(toReturn)
      param.turnsSinceHeads = 0
    -- Conjure
    elseif dirChance > 500
    then
      trace("P2 Conjure")
      attack_conjure(toReturn)
    -- Flipkick
    else
      trace("P2 Flashkick")
      attack_flipKick(toReturn)
    end
  elseif param.phase == 3 then
    debugPalette("Debug_Green")
  else
    debugPalette("Debug_Yellow")
    trace("!!!!!WE SHOULD NEVER GET HERE!!!!!")
    attack_flipKick(toReturn)
  end

  -- Debug Time --
  local s = string.format(
    "Phase %i : HP %06i/%06i Turn %i. Heads Turn %i",
    param.phase,
    me.Lifebar,
    me.MaxLife,
    --me.Superbar,
    battleData.turnNum,
    param.turnsSinceHeads
  )
  trace(s)

  return toReturn
end --OnBattleAttack()