require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

-- Attacks --
local function attack_scythe(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
end

local function attack_twirl(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("U+Attack")
end

local function attack_trap(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("D+Attack")
end

local function attack_superInferno(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = true
  end
  doMotion("U+Heruka")
end

local function attack_superTrap(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = true
  end
  doMotion("X+Heruka")
end

local function attack_superScorpion(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = true
  end
  doMotion("D+Heruka")
end

-- sequence keys
local sequence = {
  twirl = 0,
  scytheFull = 1,
  trap = 2,
  -- supers --
  scorpion = 3,
  superTrap = 4,
  inferno = 5,
}

-- the initialization function for this AI
function OnInit()
  param.time = 0
  --
  param.battleSeq = 0  
  param.battleSubSeq = 0
  param.battleMaxTimeout = 60 * 5 -- just in case
  param.battleTimeout = 60 * 1 -- default for our own sequence
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  while true do
    me, player = getMe(), getPlayer()

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()

  trace("HP: %05i/%05i; Meter: %02.2f" % { me.Lifebar, me.MaxLife, me.Superbar })

  -- lets try this!
  local _maxSeq = 2 -- 6 if we have meter ;)
  param.battleSeq = random(_maxSeq)
  param.battleSubSeq = 0 
  param.time = 0
  trace(param.battleSeq)

  -- we will never do supers :)
  toReturn.meterBurn = false
  toReturn.pressAction = false
  toReturn.pressDash = false

  --[[
  if param.battleSeq == sequence.twirl
  then
    attack_twirl(toReturn)
  elseif param.battleSeq == sequence.scytheFull
  then
    attack_scythe(toReturn)
  elseif param.battleSeq == sequence.trap
  then
    attack_trap(toReturn)
  elseif param.battleSeq == sequence.scorpion
  then
    attack_superScorpion(toReturn)
  else
    -- do nothing! --
  end
  ]]

  return toReturn
end --OnBattleAttack()

function OnBattleTurnUpdate(battleData)
  local me = getMe()

  trace(param.time)

  --[[
  -- the loop --
  if param.time <= param.battleMaxTimeout
  then
    -- Scythe Followup --
    if param.battleSeq == sequence.scytheFull
    then
      if param.time >= param.battleTimeout
      then
        debugPalette("Debug_Black")
        -- Do nothing, which exits --
      elseif param.battleSubSeq == 0 
      then
        if param.time >= 32 then
          attack_scythe()
          param.battleSubSeq = 1
        end
        debugPalette("Debug_LightBlue")
      elseif param.battleSubSeq == 1
      then
        debugPalette("Debug_Blue")
      else
        debugPalette("Debug_White")
        addInput(dirs.N)
      end
    elseif param.battleSeq == sequence.scorpion
    then
      if param.time >= param.battleTimeout
      then
        debugPalette("Debug_Black")
        -- Do nothing, which exits --
      elseif param.battleSubSeq == 0 
      then
        debugPalette("Debug_LightRed")
      else
        debugPalette("Debug_White")
        addInput(dirs.N)
      end
    end
  end
  ]]
  -- update only if not hitstop
  if update_ok()
  then
    param.time = param.time + 1
  end
end