require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")


local function block()
  doMotion("X+WorldGuard")
end

local function attack_seppuku(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
  end
  doMotion("D+Heruka")
end

local function attack_rekka(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
  end
  doMotion("X+Heruka")
end

local function attack_morphSlash(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
  end
  doMotion("U+Attack")
end

local function attack_burst(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = false
  end
  doMotion("D+Attack")
end

local function attack_kick(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
  end
  doMotion("X+Attack")
end

local function SetBossPhase()
  local me = getMe()

  local HP = me.LifePct

  if HP < 1/3 then
    param.phase = 2
  elseif HP < 2/3 then
    param.phase = 1
  else
    param.phase = 0 
  end

  if param.phase == 2 then
    me.DamageMult = param.originalDamageMult * 1.3
    me.BattleSpeedMult = param.originalSpeed * 1.4
  elseif param.phase == 1 then
    me.DamageMult = param.originalDamageMult * 1.2
    me.BattleSpeedMult = param.originalSpeed * 1.1
  else
    --
  end

end

-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  local me, player = getMe(), getPlayer()
  -- Set origin
  param.origin = { x = me.XPos, y = me.YPos }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
  --
  param.time = 0
  param.originalSpeed = me.BattleSpeedMult
  param.originalDamageMult = me.DamageMult
  --
  param.phase = 0 
  SetBossPhase()

end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  
  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end
  
  while true do
    me, player = getMe(), getPlayer()
    --
    if aiDebug() then
    end

    if tick_ok() then
      param.time = param.time + 1
    end

    SetBossPhase()

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local me = getMe()
  local toReturn = DefaultOnBattleAttack(battleData)

  SetBossPhase()

  trace(param.phase)
  attack_kick(toReturn)

  local dirChance = random(1000)
  local actionChance = random(1000)
  if param.phase >= 2 then
    if actionChance > 667 then
      attack_seppuku(toReturn)
    elseif dirChance > 667 then
      attack_burst(toReturn)
    elseif dirChance < 334 then
      attack_rekka(toReturn)
    end
  elseif param.phase >= 1 then
    if actionChance > 667 then
      attack_burst(toReturn)
    elseif dirChance > 667 then
      attack_rekka(toReturn)
    elseif dirChance < 334 then
      attack_morphSlash(toReturn)
    end
  else
    if actionChance > 667 then
      attack_morphSlash(toReturn)
    end
  end

  return toReturn
end --OnBattleAttack()