require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function block()
  doMotion("X+WorldGuard")
end

local function attack_spin(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = true
  end
  doMotion("U+Heruka")
end

local function attack_meteor(data)
  if data ~= nil then
    data.dir = dirs.D
    data.pressAction = true
  end
  doMotion("D+Heruka")
end

local function attack_chomp(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
  end
  doMotion("X+Heruka")
  param.attackCooldown = 45
end

local function attack_tailSlam(data)
  if data ~= nil then
    data.dir = dirs.U
    data.pressAction = false
  end
  doMotion("U+Attack")
  param.attackCooldown = 50
end

local function attack_swipe(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
  end
  doMotion("X+Attack")
end

local function attackX()
  local w = param.attackRangeX
  if param.bossBurstedMode then
    w = param.attackRangeRageX
  end
  return w
end

local function noticeX()
  local w = param.sightRangeX
  if param.bossBurstedMode then
    w = param.sightRangeRageX
  end
  return w
end

-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  local me, player = getMe(), getPlayer()

  -- Set origin
  param.origin = { x = me.XPos, y = me.YPos }
  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end

  param.time = 0
  param.attackCooldown = 0 

  param.floorDistOK = 120
  param.attackRangeX = 160 * 12
  param.attackRangeY = 160 * 11
  param.sightRangeX = 160 * 30
  param.sightRangeY = 160 * 9
  --
  param.attackRangeRageX = 160 * 6
  param.attackRangeRageY = 160 * 11
  param.sightRangeRageX = 160 * 40
  param.sightRangeRageY = 160 * 9
  
  param.bossBurstedMode = false
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()
  local target = getClosestPartyMember()

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do

  end

  while true do
    me, player = getMe(), getPlayer()
    target = getClosestPartyMember()
    --
    if aiDebug() then
      draw_bar(param.attackCooldown, 0, 100)
    end

    if tick_ok() then
      if not me:hasTag("Attack") then
        param.attackCooldown = math.max(0, param.attackCooldown - 1)
      end
      --param.time = param.time + 1
    end
    
    if bossBursted() 
    then
      param.attackCooldown = 24
      --
      param.bossBurstedMode = true
      me.InvinFlashTime = 60 * 6
    end
    
    if param.bossBurstedMode 
    and me.InvinFlashTime <= 0
    then
      param.bossBurstedMode = false
    end

    if isInRange(target, me.XPos, me.YPos, attackX(), param.attackRangeY)
    and dist_sprite(target) >= 0 
    and ( param.bossBurstedMode or sprite_vulnerable(target) )
    and not me:hasTag("Attack")
    and param.attackCooldown <= 0
    and me.OnGround > 0 
    and me.FloorFrontDist <= param.floorDistOK 
    then
      attack_chomp()
      if param.bossBurstedMode 
      and dist_sprite(target) < 160 * 4
      then
        attack_spin()
      end
    elseif isInRange(target, me.XPos, me.YPos, attackX(), param.attackRangeY)
    and dist_sprite(target) >= 0 
    and ( param.bossBurstedMode or sprite_vulnerable(target) )
    and not me:hasTag("Attack")
    and param.attackCooldown <= 0
    and me.OnGround > 0 
    and me.FloorFrontDist <= param.floorDistOK 
    then
      attack_tailSlam()
    elseif isInRange(target, me.XPos, me.YPos, noticeX(), param.attackRangeY)
    and dist_sprite(target) > 0
    and me.OnGround > 0 
    and param.bossBurstedMode
    then
      approach(target.XPos)
    elseif isInRange(target, me.XPos, me.YPos, attackX(), param.attackRangeY)
    and dist_sprite(target) < 0
    and not me:hasTag("Attack")
    and param.attackCooldown <= 0
    and me.OnGround > 0 
    then
      turn_around(30)
      param.attackCooldown = 20
    end
    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local me = getMe()
  local toReturn = DefaultOnBattleAttack(battleData)

  local dirChance = random(1000)
  local actionChance = random(1000)

  -- Default
  attack_swipe(toReturn)

  -- Directions
  if dirChance > 667 then
    if actionChance > 667
    and me.HealthPct < 1/3 then
      --attack_meteor(toReturn)
    else
      attack_chomp(toReturn)
    end
  elseif dirChance < 334 then
    if actionChance > 667
    and me.HealthPct < 2/3 then
      attack_spin(toReturn)
    else
      attack_tailSlam(toReturn)
    end
  end

  return toReturn
end --OnBattleAttack()