// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
vec4 EncodeLightMap(vec3 light)
{
    float ik = 0.333333333f;
    float scale = max(light.r, max(light.g, light.b));
    float inv_scale = 1.0f / scale;
    vec4 encoded = vec4(inv_scale * light, ik * scale);
    return encoded;
}
vec3 DecodeLightMap(vec4 encoded)
{
    float k = 3.0f;
    float scale = k * encoded.a;
    vec3 light = scale * encoded.rgb;
    return light;
}
uniform vec4 preg_0;
// (uv direction, filter type, size)
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define Settings preg_0
#define Frame treg_0
///////////////////////////////////////////////////////////////

void main()
{
    vec3 blurred = vec3(0, 0, 0);
    vec2 uv = xsv_TEXCOORD0;
    vec2 radius = Settings.xy;
    float size = Settings.w;
    if (size == 9.0f)
    {
        for (float i = -4.0f; i < 5.0f; i += 1.0f)
        {
            vec2 tap = i * radius + uv;
            vec4 xst_temp1 = (vec4(tap, 0, 0));
            vec4 s = textureLod(Frame, xst_temp1.xy, xst_temp1.w);
            vec3 light = DecodeLightMap(s);
            blurred.rgb += light;
        }
        blurred.rgb /= vec3(9.0f);
    }
    else if (size == 11.0f)
    {
        for (float i = -5.0f; i < 6.0f; i += 1.0f)
        {
            vec2 tap = i * radius + uv;
            vec4 xst_temp2 = (vec4(tap, 0, 0));
            vec4 s = textureLod(Frame, xst_temp2.xy, xst_temp2.w);
            vec3 light = DecodeLightMap(s);
            blurred.rgb += light;
        }
        blurred.rgb /= vec3(11.0f);
    }
    else if (size == 13.0f)
    {
        for (float i = -6.0f; i < 7.0f; i += 1.0f)
        {
            vec2 tap = i * radius + uv;
            vec4 xst_temp3 = (vec4(tap, 0, 0));
            vec4 s = textureLod(Frame, xst_temp3.xy, xst_temp3.w);
            vec3 light = DecodeLightMap(s);
            blurred.rgb += light;
        }
        blurred.rgb /= vec3(13.0f);
    }
    else if (size == 15.0f)
    {
        for (float i = -7.0f; i < 8.0f; i += 1.0f)
        {
            vec2 tap = i * radius + uv;
            vec4 xst_temp4 = (vec4(tap, 0, 0));
            vec4 s = textureLod(Frame, xst_temp4.xy, xst_temp4.w);
            vec3 light = DecodeLightMap(s);
            blurred.rgb += light;
        }
        blurred.rgb /= vec3(15.0f);
    }
    vec4 xsr_output = EncodeLightMap(blurred);
    SV_Target0 = xsr_output;
}
