// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core

out vec4 SV_Target0;
vec3 UnpackNormal(vec3 sampled_normal)
{
    return sampled_normal * 2.0f - vec3(1.0f);
}
vec3 SampleNormal(sampler2D gbuffer, vec2 texcoord)
{
    vec4 t = vec4(texcoord, 0.0f, 0.0f);
    vec4 xst_temp2 = (t);
    return UnpackNormal(textureLod(gbuffer, xst_temp2.xy, xst_temp2.w).rgb);
}
float ConvertDepthSample(float depth)
{
    return depth;
}
vec4 GetPositionFromExponentialDepth(float depth, float near, float far, vec2 screen, mat4 ivp)
{
    vec4 p = vec4(screen.x, screen.y, depth, 1.0f);
    far;
    // avoid warnings
    float z = near / min(-0.001f, depth - 1.0f);
    p *= vec4(-z);
    vec4 pw = ((p) * (ivp));
    return pw;
}
vec4 GetPositionFromDepth(float depth, float near, float far, vec2 screen, mat4 ivp)
{
    return GetPositionFromExponentialDepth(depth, near, far, screen, ivp);
}
uniform mat4 preg_0;
uniform mat4 preg_4;
uniform vec4 preg_8;
// (near, far, 1 / width, 1 / height)
uniform mat4 preg_9;
uniform vec4 preg_13;
uniform vec4 preg_14;
uniform vec4 preg_15;
// (hardness, alpha scale, angle cutoff scale, angle cutoff offset)
uniform vec4 preg_16;
// decal direction in world space
uniform sampler2D treg_0;
uniform sampler2D treg_1;
uniform sampler2D treg_2;


// Uniform name defines ///////////////////////////////////////
#define InvView preg_0
#define InvProjection preg_4
#define NearFar_InvRes preg_8
#define WorldToDecal preg_9
#define UvScaleOffset preg_13
#define TintColor preg_14
#define Settings preg_15
#define Direction preg_16
#define Depth treg_0
#define Diffuse treg_1
#define Normals treg_2
///////////////////////////////////////////////////////////////

void main()
{
    vec2 tex = gl_FragCoord.xy * NearFar_InvRes.zw;
    vec2 screen = tex * vec2(2, 2) + vec2(-1, -1);
    vec4 xst_temp3 = (vec4(tex, 0.0f, 0.0f));
    float depth = ConvertDepthSample(textureLod(Depth, xst_temp3.xy, xst_temp3.w).r);
    vec4 wpos = GetPositionFromDepth(depth, NearFar_InvRes.x, NearFar_InvRes.y, screen, InvProjection);
    wpos = ((wpos) * (InvView));
    vec4 dpos = ((wpos) * (WorldToDecal));
    float absz = abs(dpos.z);
    if (max(max(abs(dpos.x), abs(dpos.y)), absz) > 1.0f)
    {
        discard;
    }
    float blend = 1.0f;
    // normal angle cutoff
    if (Settings.w != -1.0f)
    {
        vec4 world_normal = vec4(SampleNormal(Normals, tex), 0.0f);
        float dotval = max(0.0f, dot(Direction, world_normal));
        blend = clamp(dotval * Settings.z + Settings.w, float(0), float(1));
    }
    vec2 uv = dpos.xy * vec2(0.5f, -0.5f) + vec2(0.5f, 0.5f);
    uv = uv * UvScaleOffset.xy + UvScaleOffset.zw;
    vec4 xst_temp4 = (vec4(uv, 0.0f, 0.0f));
    vec4 color = textureLod(Diffuse, xst_temp4.xy, xst_temp4.w);
    color.rgb *= TintColor.rgb;
    // decal hardness
    blend *= pow(1.0f - absz, 1.0f - Settings.x);
    color.a *= Settings.y;
    color.a *= blend;
    SV_Target0 = color;
}
