// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core

in vec4 xsv_TEXCOORD0;
in vec4 xsv_COLOR0;
out vec4 SV_Target0;
float ExponentialDepth(float z, float near, float far)
{
    float depth = -1.0f;
    far;
    // avoid warnings
    depth = 1.0f + near / z;
    return depth;
}
float GetDepth(float z, float near, float far)
{
    return ExponentialDepth(z, near, far);
}
bool BattleFade(vec2 screen, float t, sampler2D fade_texture, vec2 tex_size)
{
    bool cut_or_not = false;
    vec4 texcoord = vec4(screen / tex_size, 0, 0);
    vec4 xst_temp3 = (texcoord);
    float c = textureLod(fade_texture, xst_temp3.xy, xst_temp3.w).r;
    cut_or_not = c <= t;
    return cut_or_not;
}
uniform vec4 preg_0;
uniform vec4 preg_1;
uniform vec4 preg_2;
// (screen resolution, cutout factor, unused)
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;BattleFadeTexture:1;
uniform sampler2D treg_0;
uniform sampler2D treg_1;


// Uniform name defines ///////////////////////////////////////
#define NearFarPlane_Cutout preg_0
#define AlphaThreshold preg_1
#define BattleFadeParams preg_2
#define DiffuseTexture treg_0
#define BattleFadeTexture treg_1
///////////////////////////////////////////////////////////////

void main()
{
    vec2 FadeSize = BattleFadeParams.xy;
    float FadeLevel = BattleFadeParams.z;
    if (FadeLevel != 0.0f)
    {
        if (BattleFade(gl_FragCoord.xy, FadeLevel, BattleFadeTexture, FadeSize))
        {
            discard;
        }
    }
    // since this is discarding, use tex2Dlod so we avoid gradients
    vec4 coord = vec4(xsv_TEXCOORD0.xy, 0.0f, 0.0f);
    vec4 xst_temp4 = (coord);
    vec4 albedo = textureLod(DiffuseTexture, xst_temp4.xy, xst_temp4.w);
    if (albedo.a < AlphaThreshold.x)
    {
        discard;
    }
    float near = NearFarPlane_Cutout.x;
    float far = NearFarPlane_Cutout.y;
    float d = GetDepth(xsv_COLOR0.z, near, far);
    SV_Target0 = vec4(d, d, d, 1.0f);
}
