// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec2 xsv_TEXCOORD1;
in vec3 xsv_TEXCOORD2;
out vec4 SV_Target0;
//  uncomment this to check for any half-precision related problems
// /*
// */
float BLOCK_SIZE = 16.0f;
vec2 ATLAS_SIZE = vec2(1024, 4096);
uniform vec4 preg_17;
// (fog rgb, fog blend)
uniform vec4 preg_19;
// = // color, dir for each light in order
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;DiffuseTexture2:1;PaletteTexture:2;DyePaletteTexture:3;ShadowMap:4;ExtraShadowMap:5;
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define Alpha_Invert preg_17
#define FloorShadow preg_19
#define DiffuseTexture treg_0
///////////////////////////////////////////////////////////////

vec2 GetUVsForTexel(vec2 texCoords, vec2 sizeInTexels)
{
    // texCoords should be int's anyway
    // this is unnecessary on PS3 it looks like!
    vec2 extraOffset = vec2(0.5, 0.5);
    return (trunc(texCoords) + extraOffset) / sizeInTexels;
}
vec4 GetPixelValue(vec2 inPixelPos, vec2 inBlockPos)
{
    // ---------------------------
    // 3BPP
    // ---------------------------
    // if no texture atlases
    // then stop here
    // return tex2D( DiffuseTexture, inUVs ).rgb;
    vec2 finalPixelPos = (inPixelPos) * BLOCK_SIZE + (inBlockPos) * BLOCK_SIZE;
    vec4 uv = vec4(GetUVsForTexel(finalPixelPos, ATLAS_SIZE), 0.0f, 0.0f);
    vec4 xst_temp0 = (uv);
    // NORMAL IS NOT USED!
    return textureLod(DiffuseTexture, xst_temp0.xy, xst_temp0.w);
}
void main()
{
    vec3 xst_xsv_TEXCOORD2 = xsv_TEXCOORD2;
    float FADE_DIST = abs(FloorShadow.x);
    // if (abs(input.WorldPos.z) > FADE_DIST) - no cutoff
    if (abs(xst_xsv_TEXCOORD2.z) > FADE_DIST || xst_xsv_TEXCOORD2.z * FloorShadow.x > 0.0f)
    {
        SV_Target0 = vec4(0, 0, 0, 0);
        return;
    }
    xst_xsv_TEXCOORD2.z = abs(xst_xsv_TEXCOORD2.z);
    // original texel
    vec4 texelIn = GetPixelValue(xsv_TEXCOORD0, xsv_TEXCOORD1);
    // ------------
    // pixel+0 = dye index (gDiffuseTexture, b)
    // pixel+1 = palette index (gDiffuseTexture, g)
    // pixel+2  = gradient info (gDiffuseTexture, r)
    // pixel+3 = black line coefficient (gDiffuseTexture, a)
    // pixel+4 = normal map. (gDiffuseTexture2, b)
    // ------------
    // discard(texelIn.r <= 1.f/256 && blackLevel <= 1.f/256);
    // float earlyOut = (texelIn.r <= 1.f/256 && blackLevel <= 1.f/256) ? -1 : 0;
    // clip(earlyOut);
    // if no color, early out
    if (texelIn.g <= 1.f / 256.0f && texelIn.a <= 1.f / 256.0f)
    {
        SV_Target0 = vec4(0, 0, 0, 0);
        return;
    }
    float MAX_ALPHA = .75f;
    float fadeFactor = 1.f - clamp(xst_xsv_TEXCOORD2.z / FADE_DIST, float(0), float(1));
    if (texelIn.g >= 0.5f / 256.f)
    {
        SV_Target0 = vec4(vec3(12.5f / 255.f, 7.5f / 255.f, 22.5f / 255.f).rgb, MAX_ALPHA * fadeFactor * Alpha_Invert.x);
        return;
    }
    SV_Target0 = vec4(vec3(12.5f / 255.f, 7.5f / 255.f, 22.5f / 255.f).rgb, MAX_ALPHA * fadeFactor * (texelIn.a * texelIn.a) * Alpha_Invert.x);
}
