// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec4 ByteRow1;
in vec4 ByteRow2;
out vec2 xsv_TEXCOORD0;
out vec2 xsv_TEXCOORD1;
out vec3 xsv_TEXCOORD2;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_12;
uniform vec4 vreg_14;


// Uniform name defines ///////////////////////////////////////
#define World vreg_0
#define View vreg_4
#define Projection vreg_8
#define NormalMirrorFlip vreg_12
#define FloorShadow vreg_14
///////////////////////////////////////////////////////////////

// {fade dist, y pos, unused, unused}
void main()
{
    vec4 xst_ByteRow1 = ByteRow1;
    bool bMirrored = (NormalMirrorFlip.x < 0.0f);
    bool isOnRightEdgeOfBlock = (xst_ByteRow1.z >= 128.0f);
    bool isOnBottomEdgeOfBlock = (xst_ByteRow1.w >= 128.0f);
    // basically, bMirrored negates isOnRightEdgeOfBlock, so we check if those are not equal instead of checking isOnRightEdgeOfBlock by itself
    // firstly, our world position is screenBlockX (or Y) * blocksize
    gl_Position = vec4(xst_ByteRow1.xy * 16.0f, 0, 1);
    gl_Position.x += float((isOnRightEdgeOfBlock != bMirrored) ? 16 : 0);
    gl_Position.y += float((isOnBottomEdgeOfBlock) ? 0 : 16);
    // these were in image space
    gl_Position = ((gl_Position) * (World));
    // now, in WORLD space, stick us on the floor!
    float originalZ = gl_Position.z;
    gl_Position.z = gl_Position.y - FloorShadow.y;
    if (FloorShadow.x > 0.0f)
        gl_Position.z = -gl_Position.z;
    gl_Position.z += originalZ;
    // offset from the character's Z, not Z=0
    gl_Position.y = FloorShadow.y;
    // output.Position.xy -= EXTRA_PIXEL_OFFSET;
    xsv_TEXCOORD2 = gl_Position.xyz;
    xsv_TEXCOORD2.z -= originalZ;
    // to compute the FADE as if our original Z was 0
    gl_Position = ((gl_Position) * (View));
    gl_Position = ((gl_Position) * (Projection));
    // atlas block number to look up
    xst_ByteRow1.z -= float((isOnRightEdgeOfBlock) ? 128 : 0);
    xst_ByteRow1.w -= float((isOnBottomEdgeOfBlock) ? 128 : 0);
    // pixel offset within the block (0 = left/top, 1 = right/bottom)
    float pixelX = float((isOnRightEdgeOfBlock != bMirrored ? 1 : 0));
    float pixelY = (isOnBottomEdgeOfBlock ? 0.96 : 0);
    xsv_TEXCOORD0 = vec2(pixelX, pixelY);
    xsv_TEXCOORD1 = xst_ByteRow1.zw;
}
