// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
vec4 EncodeLightMap(vec3 light)
{
    float ik = 0.333333333f;
    float scale = max(light.r, max(light.g, light.b));
    float inv_scale = 1.0f / scale;
    vec4 encoded = vec4(inv_scale * light, ik * scale);
    return encoded;
}
//  Simple shader for passing through an input texture with an alpha
//  blend value passed in as a shader constant.
uniform vec4 preg_0;
// (ambient rgb, unused)
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define Default preg_0
#define Texture treg_0
///////////////////////////////////////////////////////////////

void main()
{
    vec4 xst_temp0 = (vec4(xsv_TEXCOORD0.x, 1.0f - xsv_TEXCOORD0.y, 0, 0));
    vec4 ambient = textureLod(Texture, xst_temp0.xy, xst_temp0.w);
    vec4 normalized = vec4(0, 0, 0, 0);
    if (ambient.w == 0.0f)
    {
        normalized.rgb = Default.rgb;
    }
    else
    {
        normalized.rgb = ambient.rgb / ambient.a;
    }
    vec4 encoded = EncodeLightMap(normalized.rgb);
    SV_Target0 = encoded;
}
