// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec4 xsv_COLOR0;
out vec4 SV_Target0;
// unused, but set for the whole Otter pass
uniform vec2 preg_1;
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;ColorLayer:0;LineLayer:1;ShadeLayer:2;Palette:3;
uniform sampler2D treg_0;
uniform sampler2D treg_1;
uniform sampler2D treg_2;
uniform sampler2D treg_3;


// Uniform name defines ///////////////////////////////////////
#define ImageSize preg_1
#define ColorLayer treg_0
#define LineLayer treg_1
#define ShadeLayer treg_2
#define Palette treg_3
///////////////////////////////////////////////////////////////

vec4 GradientColor(float intensityIn, float paletteIndex)
{
    // this gets lots simpler, since u is now intensity and v is index!
    vec4 color = texture(Palette, vec2(intensityIn * 7.f / 8.f + 0.5f / 8.f, paletteIndex * 255.f / 256.f + 0.5f / 256.f));
    // EXACT COORDS MY GOODNESS!  Maybe even on XBox?
    bool lighting = (color.a >= 128.f / 255.f);
    color.a = (color.a - (float(lighting) * 128.f / 255.f)) * 2.f;
    return color;
}
void main()
{
    vec2 xst_xsv_TEXCOORD0 = xsv_TEXCOORD0;
    // REMEMBER TO PORT THIS TO PS3!
    // color needs to be interpolated by hand, dang.
    // SO DO LINES AND SHADE WHEE, 4x the pixel work!
    vec2 RENDER_OFFSET = vec2(0.5f, 0.5f);
    // float2(0,0); //float2(0.5f, 0.5f) // on DX it's one, on GL it's the other...
    vec2 interpVals = modf((xst_xsv_TEXCOORD0 * ImageSize) + RENDER_OFFSET, xst_xsv_TEXCOORD0);
    // keep these around for later
    xst_xsv_TEXCOORD0 -= RENDER_OFFSET;
    xst_xsv_TEXCOORD0 = (xst_xsv_TEXCOORD0) / ImageSize;
    // these are UL
    vec2 coordsUR = xst_xsv_TEXCOORD0 + vec2(1.f / ImageSize.x, 0);
    vec2 coordsDL = xst_xsv_TEXCOORD0 + vec2(0, 1.f / ImageSize.y);
    vec2 coordsDR = xst_xsv_TEXCOORD0 + vec2(1.f / ImageSize.x, 1.f / ImageSize.y);
    // in float4s, storing texels as UL UR DL DR
    vec4 lineData = vec4(texture(LineLayer, xst_xsv_TEXCOORD0).a, texture(LineLayer, coordsUR).a, texture(LineLayer, coordsDL).a, texture(LineLayer, coordsDR).a);
    vec4 shadeData = vec4(texture(ShadeLayer, xst_xsv_TEXCOORD0).a, texture(ShadeLayer, coordsUR).a, texture(ShadeLayer, coordsDL).a, texture(ShadeLayer, coordsDR).a);
    vec4 colorData = vec4(texture(ColorLayer, xst_xsv_TEXCOORD0).a, texture(ColorLayer, coordsUR).a, texture(ColorLayer, coordsDL).a, texture(ColorLayer, coordsDR).a);
    // leaving this here on Windows because some cards maybe support if's being fast...
    if (!any(notEqual(colorData, vec4(0.0f))) && !any(notEqual(lineData, vec4(0.0f))))
    {
        SV_Target0 = vec4(0, 0, 0, 0);
    }
    else
    {
        lineData = trunc(lineData * 16.0f) / 16.0f;
        // quantize because it looks better!
        lineData = vec4(1.f) - lineData;
        // lop off the bottom 100 and stretch the result because 100 is the darkest it goes...
        shadeData = ((shadeData * 255.f) - vec4(100.f)) / 155.f;
        vec4 colorOutUL = GradientColor(shadeData.x, colorData.x);
        vec4 colorOutUR = GradientColor(shadeData.y, colorData.y);
        vec4 colorOutDL = GradientColor(shadeData.z, colorData.z);
        vec4 colorOutDR = GradientColor(shadeData.w, colorData.w);
        // NOW FOR EACH DAMN COLOR
        // apply black line, if any
        colorOutUL.a = max(colorOutUL.a, lineData.x);
        colorOutUL.rgb = mix(colorOutUL.rgb, vec3(0), vec3(lineData.x));
        colorOutUR.a = max(colorOutUR.a, lineData.y);
        colorOutUR.rgb = mix(colorOutUR.rgb, vec3(0), vec3(lineData.y));
        colorOutDL.a = max(colorOutDL.a, lineData.z);
        colorOutDL.rgb = mix(colorOutDL.rgb, vec3(0), vec3(lineData.z));
        colorOutDR.a = max(colorOutDR.a, lineData.w);
        colorOutDR.rgb = mix(colorOutDR.rgb, vec3(0), vec3(lineData.w));
        SV_Target0 = mix(mix(colorOutUL, colorOutUR, vec4(interpVals.x)), mix(colorOutDL, colorOutDR, vec4(interpVals.x)), vec4(interpVals.y));
    }
}
