// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec4 xsv_COLOR0;
out vec4 SV_Target0;
//  computes the luminance value for an RGB color
float RgbToLuminance(vec3 color)
{
    return dot(color, vec3(0.212671, 0.715160, 0.072169));
}
uniform vec4 preg_0;
// { tex bias, use mips, grayscale, unused }
uniform vec4 preg_1;
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define BiasMipsGray preg_0
#define UvScale preg_1
#define Texture treg_0
///////////////////////////////////////////////////////////////

void main()
{
    SV_Target0 = xsv_COLOR0;
    float bias = BiasMipsGray.x;
    bool use_mips = BiasMipsGray.y != 0.0f;
    vec2 t = xsv_TEXCOORD0 * UvScale.xy;
    if (use_mips)
        SV_Target0 *= mix(vec4(1, 1, 1, 1), clamp(texture(Texture, t), vec4(0), vec4(1)), vec4(bias));
    else
    {
        vec4 xst_temp1 = (vec4(t, 0, 0));
        SV_Target0 *= mix(vec4(1, 1, 1, 1), clamp(textureLod(Texture, xst_temp1.xy, xst_temp1.w), vec4(0), vec4(1)), vec4(bias));
    }
    vec3 grayscale = vec3(RgbToLuminance(SV_Target0.rgb));
    SV_Target0.rgb = mix(SV_Target0.rgb, grayscale, vec3(BiasMipsGray.z));
}
