// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
vec4 GetPositionFromExponentialDepth(float depth, float near, float far, vec2 screen, mat4 ivp)
{
    vec4 p = vec4(screen.x, screen.y, depth, 1.0f);
    far;
    // avoid warnings
    float z = near / min(-0.001f, depth - 1.0f);
    p *= vec4(-z);
    vec4 pw = ((p) * (ivp));
    return pw;
}
vec4 GetPositionFromDepth(float depth, float near, float far, vec2 screen, mat4 ivp)
{
    return GetPositionFromExponentialDepth(depth, near, far, screen, ivp);
}
//  Skybox rendering shader
uniform mat4 preg_0;
uniform vec4 preg_4;
// camera xyz position, near plane distance
uniform samplerCube treg_0;


// Uniform name defines ///////////////////////////////////////
#define InvViewProjection preg_0
#define CameraPos_Near preg_4
#define Skybox treg_0
///////////////////////////////////////////////////////////////

void main()
{
    vec2 screen = (xsv_TEXCOORD0 - vec2(0.5f)) * vec2(2.0f, -2.0f);
    float near = CameraPos_Near.x;
    float far = CameraPos_Near.y;
    vec4 near_point = GetPositionFromDepth(0.0f, near, far, screen, InvViewProjection);
    vec4 far_point = GetPositionFromDepth(1.0f, near, far, screen, InvViewProjection);
    vec3 ray = normalize(far_point.xyz - near_point.xyz);
    ray.x = -ray.x;
    vec4 xst_temp3 = (vec4(ray, 0));
    SV_Target0 = textureLod(Skybox, xst_temp3.xyz, xst_temp3.w);
}
