// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
float SHIFT_LEFT_08 = 256.0f;
float MAX_24_BIT = 16777215.0f;
//  unpacks a float in the [0.0, 1.0] range from three 8-bit values
float rgb8_to_unorm(vec3 encoded)
{
    float scaled = SHIFT_LEFT_08 * encoded.x + encoded.y;
    scaled = SHIFT_LEFT_08 * scaled + encoded.z;
    scaled = SHIFT_LEFT_08 * scaled;
    return scaled / MAX_24_BIT;
}
uniform vec4 preg_0;
uniform vec4 preg_1;
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define SampleDelta_NearFar preg_0
#define Sharpness preg_1
#define Ssao treg_0
///////////////////////////////////////////////////////////////

//  Gaussian coefficients
float gaussian[] = float[](0.153170f, 0.144893f, 0.122649f, 0.092902f, 0.062970f);
// stddev = 2.0
// { 0.111220, 0.107798, 0.098151, 0.083953, 0.067458, 0.050920, 0.036108 }; // stddev = 3.0
void main()
{
    vec2 delta = SampleDelta_NearFar.xy;
    float depth_range = abs(SampleDelta_NearFar.z - SampleDelta_NearFar.w);
    float weight_sum = gaussian[0];
    vec4 xst_temp0 = (vec4(xsv_TEXCOORD0, 0.0f, 0.0f));
    vec4 depth_ao = textureLod(Ssao, xst_temp0.xy, xst_temp0.w);
    float sample_sum = weight_sum * depth_ao.a;
    float unpacked = rgb8_to_unorm(depth_ao.rgb);
    float depth = unpacked;
    for (int i = -3; i <= 3; i += 1)
    {
        if (i != 0)
        {
            vec4 t = vec4(xsv_TEXCOORD0 + float(i) * delta, 0.0f, 0.0f);
            vec4 xst_temp1 = (t);
            vec4 s = textureLod(Ssao, xst_temp1.xy, xst_temp1.w);
            float a = s.a;
            float d = rgb8_to_unorm(s.rgb);
            int i_abs = abs(i);
            float w = 0.0f + gaussian[i_abs];
            // the paper had 0.3f here instead of 0.0f, which seems weird - rthomas
            w *= max(0.0f, 1.0f - (Sharpness.x * 1.0f) * abs(d - depth));
            sample_sum += a * w;
            weight_sum += w;
        }
    }
    SV_Target0 = vec4(depth_ao.rgb, sample_sum / weight_sum);
}
