// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec4 xsv_TEXCOORD1;
in vec3 xsv_TEXCOORD2;
in vec4 xsv_TEXCOORD3;
in vec4 xsv_TEXCOORD4;
out vec4 SV_Target0;
//  uncomment this to check for any half-precision related problems
// /*
// */
float BLOCK_SIZE = 16.0f;
vec2 INV_ATLAS_SIZE = vec2(1.0f / 1024.0f, 1.0f / 4096.0f);
uniform vec4 preg_3;
// (ambient rgb, debug view)
uniform vec4 preg_16;
// = // color, dir for each light in order
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;DiffuseTexture2:1;PaletteTexture:2;DyePaletteTexture:3;ShadowMap:4;ExtraShadowMap:5;
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define Mode_Alpha_NearFar preg_3
#define NormalMirrorFlipParams preg_16
#define DiffuseTexture treg_0
///////////////////////////////////////////////////////////////

//  funtions ////////////////////////////////////////////////////////
vec4 PlatformSwizzle(vec4 x)
{
    return x.rgba;
}
// void DoDirOcclusion(in int occluderNum, in float3 pt, inout half litPct)
// {
// 	ComputeOcclusion(gDirOccluders[occluderNum], pt, litPct);
// }
//  --------- end values for PaletteGradient -----------
// =======================================================
//  Techniques
// =======================================================
// / our new function, it's much faster!
//  ---------- HERE IS MY STUFFS ------------------------
//  block - coordinates for the sprite block in the atlas
//  pixel - coordinates for the pixel within the block
vec4 GetAtlasUv(vec2 block, vec2 pixel)
{
    // const float2 atlas_pixel = pixel + round(block) * BLOCK_SIZE + 0.5f;
    vec2 atlas_pixel = pixel + round(block) * BLOCK_SIZE;
    vec2 uv = trunc(atlas_pixel) * INV_ATLAS_SIZE;
    return vec4(uv, 0, 0);
}
//  This shader is used for sprite depth pass draws for shadow maps and for sprite silhouette draws
void main()
{
    vec2 xst_xsv_TEXCOORD0 = xsv_TEXCOORD0;
    // original texel
    if (NormalMirrorFlipParams.x < 0.0f)
    {
        // input.PixelPos.x = saturate((15.0f / 16.0f) - input.PixelPos.x);
        xst_xsv_TEXCOORD0.x = clamp(1.0f - xst_xsv_TEXCOORD0.x, float(0), float(1));
    }
    // input.PixelPos.x -= (input.PixelPos.x - saturate(15.f/16.f - input.PixelPos.x)) * (1.f - saturate(NormalMirrorFlipParams.x));
    // half2 lerpVal = modf(input.PixelPos * 16.f, input.PixelPos);
    vec2 lerpVal = modf(xst_xsv_TEXCOORD0 * 15.984375f, xst_xsv_TEXCOORD0);
    // 15.984375 = 15 63/64, should be an exact float
    // BlockPos.zw : position of block to our right, with -1 meaning no block
    // BlockInfo.xy : position of block below us, with -1 meaning no block
    // BlockInfo.zw : position of block below-right, with -1 meaning no block
    // 0 = us, 1 = to-right, 2 = below, 3 = below-right
    vec2 block0 = xsv_TEXCOORD1.xy;
    vec2 pixel0 = xst_xsv_TEXCOORD0;
    vec4 uv = GetAtlasUv(block0, pixel0);
    vec4 xst_temp3 = (uv);
    vec4 texel0 = PlatformSwizzle(textureLod(DiffuseTexture, xst_temp3.xy, xst_temp3.w));
    // if no color, early out
    if (texel0.g <= 1.f / 256.0f && texel0.a <= 1.f / 256.0f)
    {
        discard;
    }
    float near = Mode_Alpha_NearFar.z;
    float far = Mode_Alpha_NearFar.w;
    float d = (-xsv_TEXCOORD2.z - near) / (far - near);
    SV_Target0 = vec4(d, d, d, d);
    // SILHOUETTE
}
