// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec4 xsv_TEXCOORD1;
in vec3 xsv_TEXCOORD2;
in vec4 xsv_TEXCOORD3;
in vec4 xsv_TEXCOORD4;
out vec4 SV_Target0;
//  uncomment this to check for any half-precision related problems
// /*
// */
float BLOCK_SIZE = 16.0f;
vec2 INV_ATLAS_SIZE = vec2(1.0f / 1024.0f, 1.0f / 4096.0f);
vec4 DEBUG_SPRITE_ALPHA_COLOR = vec4(1, 0, 0, 0.75);
//  frame constants //////////////////////////////////////////////
uniform vec4 preg_0;
//  instance constants ////////////////////////////////////////////
uniform vec4 preg_15;
// (ambient rgb, debug view)
uniform vec4 preg_16;
uniform vec4 preg_17;
// (alpha, invert, unused, unused)
uniform vec4 preg_18;
// = // color, dir for each light in order
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;DiffuseTexture2:1;PaletteTexture:2;DyePaletteTexture:3;ShadowMap:4;ExtraShadowMap:5;
uniform sampler2D treg_0;
uniform sampler2D treg_2;
uniform sampler2D treg_3;


// Uniform name defines ///////////////////////////////////////
#define Camera_DebugAlpha preg_0
#define Ambient_Debug preg_15
#define NormalMirrorFlipParams preg_16
#define Alpha_Invert preg_17
#define FogColor preg_18
#define DiffuseTexture treg_0
#define PaletteTexture treg_2
#define DyePaletteTexture treg_3
///////////////////////////////////////////////////////////////

//  funtions ////////////////////////////////////////////////////////
vec4 PlatformSwizzle(vec4 x)
{
    return x.rgba;
}
// void DoDirOcclusion(in int occluderNum, in float3 pt, inout half litPct)
// {
// 	ComputeOcclusion(gDirOccluders[occluderNum], pt, litPct);
// }
//  --------- end values for PaletteGradient -----------
// =======================================================
//  Techniques
// =======================================================
// / our new function, it's much faster!
//  ---------- HERE IS MY STUFFS ------------------------
//  block - coordinates for the sprite block in the atlas
//  pixel - coordinates for the pixel within the block
vec4 GetAtlasUv(vec2 block, vec2 pixel)
{
    // const float2 atlas_pixel = pixel + round(block) * BLOCK_SIZE + 0.5f;
    vec2 atlas_pixel = pixel + round(block) * BLOCK_SIZE;
    vec2 uv = trunc(atlas_pixel) * INV_ATLAS_SIZE;
    return vec4(uv, 0, 0);
}
float GradientColor(float intensityIn, float paletteIndex, out vec4 color)
{
    // this gets lots simpler, since u is now intensity and v is index!
    vec4 uv = vec4(intensityIn * 7.f / 8.f + 0.5f / 8.f, paletteIndex * 255.f / 256.f + 0.5f / 256.f, 0.0f, 0.0f);
    vec4 xst_temp2 = (uv);
    color = textureLod(PaletteTexture, xst_temp2.xy, xst_temp2.w);
    // EXACT COORDS MY GOODNESS!  Maybe even on XBox?
    bool lighting = (color.a >= 128.f / 255.f);
    color.a = (color.a - (float(lighting) * 128.f / 255.f)) * 2.f;
    return float(!lighting);
}
//  assumes that output alpha isn't used
void DyeGradientColor(float intensityIn, float paletteIndex, out vec4 color)
{
    // this gets lots simpler, since u is now intensity and v is index!
    vec4 uv = vec4(intensityIn * 7.f / 8.f + 0.5f / 8.f, paletteIndex * 255.f / 256.f + 0.5f / 256.f, 0.0f, 0.0f);
    vec4 xst_temp3 = (uv);
    color = textureLod(DyePaletteTexture, xst_temp3.xy, xst_temp3.w);
}
//  NOTE: debug view constants; must be kept in sync with the RenderJobDirectionalLight::DebugView enum
float DebugView_None = 0.0f;
float DebugView_Albedo = 1.0f;
float DebugView_Normals = 2.0f;
//  our new function, it's much faster!
void main()
{
    vec2 xst_xsv_TEXCOORD0 = xsv_TEXCOORD0;
    if (NormalMirrorFlipParams.x < 0.0f)
    {
        // input.PixelPos.x = saturate((15.0f / 16.0f) - input.PixelPos.x);
        xst_xsv_TEXCOORD0.x = clamp(1.0f - xst_xsv_TEXCOORD0.x, float(0), float(1));
    }
    // input.PixelPos.x -= (input.PixelPos.x - saturate(15.f/16.f - input.PixelPos.x)) * (1.f - saturate(NormalMirrorFlipParams.x));
    // half2 lerpVal = modf(input.PixelPos * 16.f, input.PixelPos);
    vec2 lerpVal = modf(xst_xsv_TEXCOORD0 * 15.984375f, xst_xsv_TEXCOORD0);
    // 15.984375 = 15 63/64, should be an exact float
    // BlockPos.zw : position of block to our right, with -1 meaning no block
    // BlockInfo.xy : position of block below us, with -1 meaning no block
    // BlockInfo.zw : position of block below-right, with -1 meaning no block
    // We do manual bilinear filtering of the sprites. This might cause use to sample into neighboring blocks.
    // All the pixel/block/texel values below correspond to this pixel sampling pattern:
    //    ---------
    //    | 0 | 1 |
    //    ---------
    //    | 2 | 3 |
    //    ---------
    vec2 block0 = xsv_TEXCOORD1.xy;
    vec2 pixel0 = xst_xsv_TEXCOORD0;
    vec4 uv = GetAtlasUv(block0, pixel0);
    vec4 xst_temp7 = (uv);
    vec4 texel0 = PlatformSwizzle(textureLod(DiffuseTexture, xst_temp7.xy, xst_temp7.w));
    float bUseBlockToRight = step(14.5f, pixel0.x);
    float bUseBlockBelow = step(14.5f, pixel0.y);
    float pixel_right_x = (1.0f - bUseBlockToRight) * (pixel0.x + 1.0f);
    float pixel_below_y = (1.0f - bUseBlockBelow) * (pixel0.y + 1.0f);
    // this was a bug, but looks like a neat effect
    // const float pixel_right_x = (1.0f - bUseBlockToRight);
    // const float pixel_below_y = (1.0f - bUseBlockBelow);
    vec2 block1 = mix(block0, xsv_TEXCOORD1.zw, vec2(bUseBlockToRight));
    // us, right
    vec2 pixel1 = vec2(pixel_right_x, pixel0.y);
    uv = GetAtlasUv(block1, pixel1);
    float block_right_exists = step(0.0f, xsv_TEXCOORD1.z);
    float is_valid_sample = sign((1.0f - bUseBlockToRight) + block_right_exists);
    vec4 xst_temp8 = (uv);
    vec4 texel1 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp8.xy, xst_temp8.w));
    vec2 block2 = mix(block0, xsv_TEXCOORD3.xy, vec2(bUseBlockBelow));
    // us, below
    vec2 pixel2 = vec2(pixel0.x, pixel_below_y);
    uv = GetAtlasUv(block2, pixel2);
    float block_below_exists = step(0.0f, xsv_TEXCOORD3.x);
    is_valid_sample = sign((1.0f - bUseBlockBelow) + block_below_exists);
    vec4 xst_temp9 = (uv);
    vec4 texel2 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp9.xy, xst_temp9.w));
    vec2 block3 = mix(block2, mix(xsv_TEXCOORD1.zw, xsv_TEXCOORD3.zw, vec2(bUseBlockBelow)), vec2(bUseBlockToRight));
    vec2 pixel3 = vec2(pixel_right_x, pixel_below_y);
    uv = GetAtlasUv(block3, pixel3);
    float block_below_right_exists = step(0.0f, xsv_TEXCOORD3.z);
    is_valid_sample = mix(mix(1.0f, block_below_exists, bUseBlockBelow), mix(block_right_exists, block_below_right_exists, bUseBlockBelow), bUseBlockToRight);
    vec4 xst_temp10 = (uv);
    vec4 texel3 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp10.xy, xst_temp10.w));
    vec3 color = vec3(0, 0, 0);
    vec3 normal = vec3(0, 0, 0);
    // first, interpolate black levels and gradients
    // figure out black line value and gradient value
    // okay so, we can use just ONE lerp if we combine the gradient pixel, black pixel, and lighting pixel into one half3
    vec4 BlkLitNorm[2];
    // USE_LIGHTS
    // FIRST TEXEL GROUP
    // pixel+3 = black line coefficient (DiffuseTexture, a)
    BlkLitNorm[0].x = texel0.a;
    // blk0 = ul ll
    BlkLitNorm[1].x = texel1.a;
    // blk1 = ur lr so to lerp lr we just lerp these together once
    BlkLitNorm[0].y = texel2.a;
    BlkLitNorm[1].y = texel3.a;
    // NEXT TEXEL GROUP
    // pixel+2  = gradient info (DiffuseTexture, r)
    vec4 gradientVals = vec4(texel0.r, texel1.r, texel2.r, texel3.r);
    vec4 colors[4];
    // NEXT TEXEL GROUP
    // pixel+1 = palette index (DiffuseTexture, g)
    BlkLitNorm[0].z = GradientColor(gradientVals.x, texel0.g, colors[0]);
    BlkLitNorm[1].z = GradientColor(gradientVals.y, texel1.g, colors[1]);
    BlkLitNorm[0].w = GradientColor(gradientVals.z, texel2.g, colors[2]);
    BlkLitNorm[1].w = GradientColor(gradientVals.w, texel3.g, colors[3]);
    // NEXT TEXEL GROUP
    // pixel+0 = dye index (DiffuseTexture, b)
    vec4 dyeColors[4];
    DyeGradientColor(1.0f - BlkLitNorm[0].x, texel0.b, dyeColors[0]);
    DyeGradientColor(1.0f - BlkLitNorm[1].x, texel1.b, dyeColors[1]);
    DyeGradientColor(1.0f - BlkLitNorm[0].y, texel2.b, dyeColors[2]);
    DyeGradientColor(1.0f - BlkLitNorm[1].y, texel3.b, dyeColors[3]);
    // lerp the result
    BlkLitNorm[0] = mix(BlkLitNorm[0], BlkLitNorm[1], vec4(lerpVal.x));
    // left-right sides
    BlkLitNorm[0].xy = mix(BlkLitNorm[0].xz, BlkLitNorm[0].yw, vec2(lerpVal.y));
    float inv_x = 1.0f - lerpVal.x;
    float inv_y = 1.0f - lerpVal.y;
    float weights[4];
    weights[0] = (inv_x * inv_y);
    weights[1] = (lerpVal.x * inv_y);
    weights[2] = (inv_x * lerpVal.y);
    weights[3] = (lerpVal.x * lerpVal.y);
    // the eventual returned value
    vec4 _pixelOut;
    // : COLOR0;
    _pixelOut.a = weights[0] * colors[0].a + weights[1] * colors[1].a + weights[2] * colors[2].a + weights[3] * colors[3].a;
    vec4 dyeColorFINAL = weights[0] * dyeColors[0] + weights[1] * dyeColors[1] + weights[2] * dyeColors[2] + weights[3] * dyeColors[3];
    float color_threshold = 1.0f / 256.0f;
    float is_line = step(color_threshold, BlkLitNorm[0].x);
    weights[0] *= mix(step(color_threshold, texel0.g), 1.0f, is_line);
    weights[1] *= mix(step(color_threshold, texel1.g), 1.0f, is_line);
    weights[2] *= mix(step(color_threshold, texel2.g), 1.0f, is_line);
    weights[3] *= mix(step(color_threshold, texel3.g), 1.0f, is_line);
    float total_weights = max(color_threshold, weights[0] + weights[1] + weights[2] + weights[3]);
    _pixelOut.rgb = weights[0] * colors[0].rgb + weights[1] * colors[1].rgb + weights[2] * colors[2].rgb + weights[3] * colors[3].rgb;
    _pixelOut.rgb /= vec3(total_weights);
    color = mix(_pixelOut.rgb, dyeColorFINAL.rgb, vec3(BlkLitNorm[0].x));
    // apply black line, if any
    _pixelOut.a = max(_pixelOut.a, BlkLitNorm[0].x) * Alpha_Invert.x;
    _pixelOut.rgb = mix(dyeColorFINAL.rgb, _pixelOut.rgb, vec3(1.0f - BlkLitNorm[0].x));
    _pixelOut.rgb = mix(_pixelOut.rgb, FogColor.rgb, vec3(FogColor.a));
    float PREMULT_ALPHA = 1.1f;
    _pixelOut.rgb *= vec3((PREMULT_ALPHA * _pixelOut.a));
    _pixelOut.a *= (1.f / PREMULT_ALPHA);
    _pixelOut.rgb = mix(_pixelOut.rgb, vec3(1, 1, 1) - _pixelOut.rgb, vec3(Alpha_Invert.y));
    // at 0, 0
    // at 2/3, 0
    // at 1, 1
    _pixelOut.a = mix(_pixelOut.a, 0.0f, clamp(3.f * (xsv_TEXCOORD4.a - .66f), float(0), float(1)));
    // at 0, 0
    // at 1/2, 0
    // at 3/4, 1
    // so subtract 1/2 then multiply by 4
    vec3 DEATH_FADE_COLOR = vec3(0, 0, 0);
    // float3(238.f / 255.f, 34.f / 255.f, 0.f);
    _pixelOut.rgb = mix(_pixelOut.rgb, DEATH_FADE_COLOR, vec3(clamp(1.5f * xsv_TEXCOORD4.a, float(0), float(1))));
    float debug_view = Ambient_Debug.w;
    if (debug_view == DebugView_None)
    {
        SV_Target0 = mix(_pixelOut, mix(DEBUG_SPRITE_ALPHA_COLOR, _pixelOut, vec4(_pixelOut.a)), vec4(Camera_DebugAlpha.w));
    }
    else if (debug_view == DebugView_Albedo)
    {
        SV_Target0.rgb = color;
        SV_Target0.a = _pixelOut.a;
    }
    else if (debug_view == DebugView_Normals)
    {
        SV_Target0.rgb = normal * 0.5f + vec3(0.5f);
        SV_Target0.a = _pixelOut.a;
    }
    else
    {
        SV_Target0 = vec4(0, 0, 0, 0);
    }
}
