// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
in vec4 xsv_TEXCOORD1;
in vec3 xsv_TEXCOORD2;
in vec4 xsv_TEXCOORD3;
in vec4 xsv_TEXCOORD4;
out vec4 SV_Target0;
//  uncomment this to check for any half-precision related problems
// /*
// */
float BLOCK_SIZE = 16.0f;
vec2 INV_ATLAS_SIZE = vec2(1.0f / 1024.0f, 1.0f / 4096.0f);
uniform vec4 preg_3;
// (ambient rgb, debug view)
uniform vec4 preg_16;
// (fog rgb, fog blend)
uniform vec4 preg_19;
// = // color, dir for each light in order
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;DiffuseTexture2:1;PaletteTexture:2;DyePaletteTexture:3;ShadowMap:4;ExtraShadowMap:5;
uniform sampler2D treg_0;
uniform sampler2D treg_2;


// Uniform name defines ///////////////////////////////////////
#define Mode_Alpha_NearFar preg_3
#define NormalMirrorFlipParams preg_16
#define FloorShadow preg_19
#define DiffuseTexture treg_0
#define PaletteTexture treg_2
///////////////////////////////////////////////////////////////

//  funtions ////////////////////////////////////////////////////////
vec4 PlatformSwizzle(vec4 x)
{
    return x.rgba;
}
// void DoDirOcclusion(in int occluderNum, in float3 pt, inout half litPct)
// {
// 	ComputeOcclusion(gDirOccluders[occluderNum], pt, litPct);
// }
//  --------- end values for PaletteGradient -----------
// =======================================================
//  Techniques
// =======================================================
// / our new function, it's much faster!
//  ---------- HERE IS MY STUFFS ------------------------
//  block - coordinates for the sprite block in the atlas
//  pixel - coordinates for the pixel within the block
vec4 GetAtlasUv(vec2 block, vec2 pixel)
{
    // const float2 atlas_pixel = pixel + round(block) * BLOCK_SIZE + 0.5f;
    vec2 atlas_pixel = pixel + round(block) * BLOCK_SIZE;
    vec2 uv = trunc(atlas_pixel) * INV_ATLAS_SIZE;
    return vec4(uv, 0, 0);
}
float GradientColor(float intensityIn, float paletteIndex, out vec4 color)
{
    // this gets lots simpler, since u is now intensity and v is index!
    vec4 uv = vec4(intensityIn * 7.f / 8.f + 0.5f / 8.f, paletteIndex * 255.f / 256.f + 0.5f / 256.f, 0.0f, 0.0f);
    vec4 xst_temp1 = (uv);
    color = textureLod(PaletteTexture, xst_temp1.xy, xst_temp1.w);
    // EXACT COORDS MY GOODNESS!  Maybe even on XBox?
    bool lighting = (color.a >= 128.f / 255.f);
    color.a = (color.a - (float(lighting) * 128.f / 255.f)) * 2.f;
    return float(!lighting);
}
//  This shader is used for sprite depth pass draws for shadow maps and for sprite silhouette draws
void main()
{
    vec2 xst_xsv_TEXCOORD0 = xsv_TEXCOORD0;
    // original texel
    if (NormalMirrorFlipParams.x < 0.0f)
    {
        // input.PixelPos.x = saturate((15.0f / 16.0f) - input.PixelPos.x);
        xst_xsv_TEXCOORD0.x = clamp(1.0f - xst_xsv_TEXCOORD0.x, float(0), float(1));
    }
    // input.PixelPos.x -= (input.PixelPos.x - saturate(15.f/16.f - input.PixelPos.x)) * (1.f - saturate(NormalMirrorFlipParams.x));
    // half2 lerpVal = modf(input.PixelPos * 16.f, input.PixelPos);
    vec2 lerpVal = modf(xst_xsv_TEXCOORD0 * 15.984375f, xst_xsv_TEXCOORD0);
    // 15.984375 = 15 63/64, should be an exact float
    // BlockPos.zw : position of block to our right, with -1 meaning no block
    // BlockInfo.xy : position of block below us, with -1 meaning no block
    // BlockInfo.zw : position of block below-right, with -1 meaning no block
    // 0 = us, 1 = to-right, 2 = below, 3 = below-right
    vec2 block0 = xsv_TEXCOORD1.xy;
    vec2 pixel0 = xst_xsv_TEXCOORD0;
    vec4 uv = GetAtlasUv(block0, pixel0);
    vec4 xst_temp3 = (uv);
    vec4 texel0 = PlatformSwizzle(textureLod(DiffuseTexture, xst_temp3.xy, xst_temp3.w));
    if (xsv_TEXCOORD2.y < FloorShadow.y)
    {
        discard;
    }
    float bUseBlockToRight = step(14.5f, pixel0.x);
    float bUseBlockBelow = step(14.5f, pixel0.y);
    float pixel_right_x = (1.0f - bUseBlockToRight) * (pixel0.x + 1.0f);
    float pixel_below_y = (1.0f - bUseBlockBelow) * (pixel0.y + 1.0f);
    // this was a bug, but looks like a neat effect
    // const float pixel_right_x = (1.0f - bUseBlockToRight);
    // const float pixel_below_y = (1.0f - bUseBlockBelow);
    vec2 block1 = mix(block0, xsv_TEXCOORD1.zw, vec2(bUseBlockToRight));
    // us, right
    vec2 pixel1 = vec2(pixel_right_x, pixel0.y);
    uv = GetAtlasUv(block1, pixel1);
    float block_right_exists = step(0.0f, xsv_TEXCOORD1.z);
    float is_valid_sample = clamp((1.0f - bUseBlockToRight) + block_right_exists, float(0), float(1));
    vec4 xst_temp4 = (uv);
    vec4 texel1 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp4.xy, xst_temp4.w));
    vec2 block2 = mix(block0, xsv_TEXCOORD3.xy, vec2(bUseBlockBelow));
    // us, below
    vec2 pixel2 = vec2(pixel0.x, pixel_below_y);
    uv = GetAtlasUv(block2, pixel2);
    float block_below_exists = step(0.0f, xsv_TEXCOORD3.x);
    is_valid_sample = clamp((1.0f - bUseBlockBelow) + block_below_exists, float(0), float(1));
    vec4 xst_temp5 = (uv);
    vec4 texel2 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp5.xy, xst_temp5.w));
    vec2 block3 = mix(block2, mix(xsv_TEXCOORD1.zw, xsv_TEXCOORD3.zw, vec2(bUseBlockBelow)), vec2(bUseBlockToRight));
    vec2 pixel3 = vec2(pixel_right_x, pixel_below_y);
    uv = GetAtlasUv(block3, pixel3);
    float block_below_right_exists = step(0.0f, xsv_TEXCOORD3.z);
    is_valid_sample = mix(mix(1.0f, block_below_exists, bUseBlockBelow), mix(block_right_exists, block_below_right_exists, bUseBlockBelow), bUseBlockToRight);
    vec4 xst_temp6 = (uv);
    vec4 texel3 = is_valid_sample * PlatformSwizzle(textureLod(DiffuseTexture, xst_temp6.xy, xst_temp6.w));
    vec4 lerpVals[2];
    // pixel+3 = black line coefficient (DiffuseTexture, a)
    lerpVals[0].x = texel0.a;
    // blk0 = ul ll
    lerpVals[1].x = texel1.a;
    // blk1 = ur lr so to lerp lr we just lerp these together once
    lerpVals[0].y = texel2.a;
    lerpVals[1].y = texel3.a;
    // NEXT TEXEL GROUP
    // pixel+1 = palette index (DiffuseTexture, g)
    lerpVals[0].z = texel0.g;
    lerpVals[1].z = texel1.g;
    lerpVals[0].w = texel2.g;
    lerpVals[1].w = texel3.g;
    // lerp the result
    lerpVals[0] = mix(lerpVals[0], lerpVals[1], vec4(lerpVal.x));
    // left-right sides
    lerpVals[0].xy = mix(lerpVals[0].xz, lerpVals[0].yw, vec2(lerpVal.y));
    // top-bottom
    // if no color, early out
    if (lerpVals[0].x <= 1.f / 256.0f && lerpVals[0].y <= 1.f / 256.0f)
    {
        discard;
    }
    vec4 palette_color;
    GradientColor(texel0.r, texel0.g, palette_color);
    // use color: (255, 237, 39), gold-ish
    // output.Color = float4(1.f * texelIn.a, (237.f/255.f) * texelIn.a, (39.f/255.f) * texelIn.a, Mode_Alpha_NearFar.y);
    SV_Target0 = vec4(vec3(0.f), palette_color.a * Mode_Alpha_NearFar.y);
    // SILHOUETTE
}
