// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
uniform vec4 preg_0;
uniform vec4 preg_1;
// (fog rgb, fog blend)
uniform vec4 preg_2;
// (alpha, is pre-multiplied, unused, unused)
uniform vec4 preg_3;
// = { 255.f / 255.f, 0, 255.f / 255.f, 0.f };
uniform vec4 preg_4;
// = { 0.f, 255.f / 255.f, 255.f / 255.f, UNUSED };
uniform sampler2D treg_0;


// Uniform name defines ///////////////////////////////////////
#define Ambient preg_0
#define FogColor preg_1
#define Blend preg_2
#define PaletteFXColor1Pct preg_3
#define PaletteFXColor2Alpha preg_4
#define Texture treg_0
///////////////////////////////////////////////////////////////

void main()
{
    vec4 t = vec4(xsv_TEXCOORD0, 0, 0);
    vec4 xst_temp0 = (t);
    SV_Target0 = vec4(Ambient.rgb, 1.0f) * textureLod(Texture, xst_temp0.xy, xst_temp0.w);
    float luminance = 0.2126f * SV_Target0.r + 0.7152f * SV_Target0.g + 0.0722f * SV_Target0.b;
    // see https://en.wikipedia.org/wiki/Relative_luminance
    vec3 pixelPalFXColor = mix(vec3(PaletteFXColor1Pct.rgb), vec3(PaletteFXColor2Alpha.rgb), vec3(luminance));
    if (Blend.y != 0.0f)
    {
        // put the palfx color into premultiplied territory if it's premultiplied?
        pixelPalFXColor *= vec3(SV_Target0.a * Blend.y);
    }
    SV_Target0.rgb = clamp(mix(SV_Target0.rgb, pixelPalFXColor, vec3(PaletteFXColor1Pct.a)), vec3(0), vec3(1));
    // need to multiply color by sprite alpha if pre-multiplied
    SV_Target0.rgb *= vec3(mix(1.0f, Blend.r, Blend.y));
    SV_Target0.a *= Blend.r;
    if (Blend.y == 0.0f)
    {
        // do we have to do the same for fog?  What the heck do we do with premultiplied vs fog?
        SV_Target0.rgb = mix(SV_Target0.rgb, FogColor.rgb, vec3(FogColor.a));
    }
}
