// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec3 Position;
in vec3 Normal;
in vec2 TexCoord;
out vec4 xsv_TEXCOORD0;
out vec4 xsv_COLOR0;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_12;
uniform vec4 vreg_13;
uniform vec4 vreg_14;
uniform vec4 vreg_15;


// Uniform name defines ///////////////////////////////////////
#define ModelToWorld vreg_0
#define WorldToView vreg_4
#define ViewToClip vreg_8
#define InverseModelScale_DepthClamp vreg_12
#define UTransform_ZBias vreg_13
#define VTransform vreg_14
#define Animation vreg_15
///////////////////////////////////////////////////////////////

vec3 GenerateWaterMotion(vec3 pos, vec3 normal, float time, float amplitude, float speed)
{
    float phase = (pos.x + pos.y + pos.z) / 160.0f;
    float pi = 3.14159265f;
    vec2 freqs = vec2(1.414, 0.175);
    vec2 waves = pi * (fract(time * speed * freqs) * 2.0f - vec2(1.0f) + vec2(phase));
    vec2 motion = vec2(0.25f * amplitude, amplitude) * sin(waves);
    // const float3 new_pos = pos + (motion.x + motion.y) * normal;
    vec3 new_pos = pos + motion.y * normal;
    return new_pos;
}
void main()
{
    vec3 pos = Position;
    vec4 wpos = ((vec4(pos, 1.0f)) * (ModelToWorld));
    if (Animation.w == 1.0f)
    {
        wpos.xyz = GenerateWaterMotion(wpos.xyz, Normal, Animation.x, 160.0f * Animation.y, Animation.z);
    }
    vec4 cpos = ((wpos) * (WorldToView));
    gl_Position = ((cpos) * (ViewToClip));
    // this depth clamp exists so that we never miss shadow casters that are "closer" to the light than the scene is
    float min_depth = InverseModelScale_DepthClamp.w;
    gl_Position.z = max(min_depth, gl_Position.z);
    vec3 UTransform = UTransform_ZBias.xyz;
    xsv_TEXCOORD0.x = dot(UTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = dot(VTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = 1.0f - xsv_TEXCOORD0.y;
    xsv_TEXCOORD0.zw = TexCoord;
    xsv_COLOR0 = cpos;
    xsv_COLOR0.w = wpos.z;
}
