// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
vec3 xst_subscript_03_13_23(mat4 m)
{
    return vec3(m[0][3], m[1][3], m[2][3]);
}
in vec3 Position;
in vec3 Normal;
in vec2 TexCoord;
in vec4 Color;
out vec4 xsv_TEXCOORD0;
out vec3 xsv_TEXCOORD1;
out vec4 xsv_TEXCOORD2;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_12;
uniform vec4 vreg_13;
uniform vec4 vreg_14;
uniform vec4 vreg_15;


// Uniform name defines ///////////////////////////////////////
#define ModelToWorld vreg_0
#define WorldToView vreg_4
#define ViewToClip vreg_8
#define InverseModelScale_DepthClamp vreg_12
#define UTransform_ZBias vreg_13
#define VTransform vreg_14
#define Animation vreg_15
///////////////////////////////////////////////////////////////

//  foliage animation
//  This provides "chaotic" motion for leaves and branches (the entire plant, really)
vec3 GenerateFoliageMotion(vec3 vPos, vec3 vNormal, vec3 pivot, float fBranchPhase, float fTime, vec3 fEdgeAtten, float fSpeed)
{
    // Phases (object, vertex, branch)
    // fObjPhase: This ensures phase is different for different plant instances, but it should be
    // the same value for all vertices of the same plant.
    // float fObjPhase = dot(pivot.xyz, 1.0f);
    float fObjPhase = (pivot.x + pivot.y + pivot.z) / 160.0f;
    // In this sample fBranchPhase is always zero, but if you want you could somehow supply a
    // different phase for each branch.
    float phase = fBranchPhase + fObjPhase;
    // Detail phase is (in this sample) controlled by the GREEN vertex color. In your modelling program,
    // assign the same "random" phase color to each vertex in a single leaf/branch so that the whole leaf/branch
    // moves together.
    // float fVtxPhase = dot(vPos.xyz, fDetailPhase + fBranchPhase);
    // const float2 wave_input = fTime + float2(fVtxPhase, fBranchPhase);
    vec2 wave_input = vec2(fTime);
    // + fBranchPhase;
    vec4 freqs = vec4(1.975, 0.793, 0.375, 0.193);
    float pi = 3.14159265f;
    // float4 waves = pi * (frac(wave_input.xxyy * freqs * fSpeed) * 2.0f - 1.0f);// * fSpeed * fDetailFreq;
    vec4 waves = pi * (fract(wave_input.xxyy * freqs * fSpeed) * 2.0f - vec4(1.0f) + vec4(phase));
    // * fSpeed * fDetailFreq;
    // waves = SmoothTriangleWave(waves);
    waves = sin(waves);
    vec2 summed_waves = waves.xz + waves.yw;
    // const float2 summed_waves = waves.xy;
    // - fBranchAtten is how restricted this vertex of the leaf/branch is. e.g. close to the stem
    //   it should be 0 (maximum stiffness). At the far outer edge it might be 1.
    //   In this sample, this is controlled by the blue vertex color.
    // - fEdgeAtten controls movement in the plane of the leaf/branch. It is controlled by the
    //   red vertex color in this sample. It is supposed to represent "leaf stiffness". Generally, it
    //   should be 0 in the middle of the leaf (maximum stiffness), and 1 on the outer edges.
    // - Note that this is different from the Crytek code, in that we use vPos.xzy instead of vPos.xyz,
    //   because I treat y as the up-and-down direction.
    // float3 new_pos = vPos.xzy + vWavesSum.xxy * float3(fEdgeAtten * fDetailAmp * vNormal.xz, fBranchAtten * fBranchAmp);
    // float3 new_pos = vPos.xyz + float3(summed_waves.yx, 0) * float3(fEdgeAtten * fDetailAmp * vNormal.xyz);
    vec3 new_pos = vPos.xyz + fEdgeAtten * vec3(summed_waves.yx, 0) * vNormal;
    // new_pos.y += vWavesSum.y * fBranchAtten * fBranchAmp;
    return new_pos;
}
void main()
{
    vec3 pos = Position;
    vec3 strength = Animation.y * vec3(Color.r, 0.25f * Color.r, 0.0f);
    vec3 obj_pivot = xst_subscript_03_13_23(ModelToWorld);
    vec3 fpos = GenerateFoliageMotion(pos, vec3(1, 1, 0), obj_pivot, Color.g, Animation.x, strength, Animation.z);
    vec4 wpos = ((vec4(fpos, 1.0f)) * (ModelToWorld));
    vec4 cpos = ((wpos) * (WorldToView));
    gl_Position = ((cpos) * (ViewToClip));
    vec3 UTransform = UTransform_ZBias.xyz;
    xsv_TEXCOORD0.x = dot(UTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = dot(VTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = 1.0f - xsv_TEXCOORD0.y;
    xsv_TEXCOORD0.zw = TexCoord;
    // for the visual version we want to bias the depth toward the camera a bit
    // so that characters' feet aren't clipped by the floor
    float zbias = UTransform_ZBias.w;
    if (zbias != 0.0f)
    {
        vec4 biased_pos = cpos;
        biased_pos.z += zbias;
        float clip_z = dot(ViewToClip[2], biased_pos);
        float clip_w = dot(ViewToClip[3], biased_pos);
        float d = clip_z / clip_w;
        gl_Position.z = d * gl_Position.w;
    }
    xsv_TEXCOORD1 = wpos.xyz;
    vec3 is = InverseModelScale_DepthClamp.xyz;
    vec3 n = Normal.xyz * is;
    n = ((vec4(Normal.xyz, 0.0f)) * (ModelToWorld)).xyz;
    xsv_TEXCOORD2.xyz = normalize(n * is);
    xsv_TEXCOORD2.w = Color.a;
}
