// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core

in vec4 xsv_TEXCOORD0;
in vec3 xsv_TEXCOORD1;
in vec4 xsv_TEXCOORD2;
out vec4 SV_Target0;
out vec4 SV_Target1;
bool BattleFade(vec2 screen, float t, sampler2D fade_texture, vec2 tex_size)
{
    bool cut_or_not = false;
    vec4 texcoord = vec4(screen / tex_size, 0, 0);
    vec4 xst_temp0 = (texcoord);
    float c = textureLod(fade_texture, xst_temp0.xy, xst_temp0.w).r;
    cut_or_not = c <= t;
    return cut_or_not;
}
float EmissiveMaxInverse = 0.25f;
float EncodeEmissive(float e)
{
    return e * EmissiveMaxInverse;
}
uniform vec4 preg_0;
// (r, g, b, unused)
uniform vec4 preg_1;
// (alpha, emissivity, emissive intensity, unused)
uniform vec4 preg_2;
// (screen resolution, cutout factor, cutout z)
// This needs to preceed all texture defines for post-processing to work properly
// TextureNames;DiffuseTexture:0;BattleFadeTexture:1;
uniform sampler2D treg_0;
uniform sampler2D treg_1;


// Uniform name defines ///////////////////////////////////////
#define Tint preg_0
#define Alpha_Emissive preg_1
#define BattleFadeParams preg_2
#define DiffuseTexture treg_0
#define BattleFadeTexture treg_1
///////////////////////////////////////////////////////////////

void main()
{
    vec2 FadeSize = BattleFadeParams.xy;
    float FadeLevel = BattleFadeParams.z;
    if (FadeLevel != 0.0f)
    {
        if (BattleFade(gl_FragCoord.xy, FadeLevel, BattleFadeTexture, FadeSize))
        {
            discard;
        }
    }
    float AlphaThreshold = Alpha_Emissive.x;
    float Emissivity = Alpha_Emissive.y;
    float EmissiveIntensity = Alpha_Emissive.z;
    vec4 albedo = vec4(Tint.rgb, 1.0f) * texture(DiffuseTexture, xsv_TEXCOORD0.xy);
    SV_Target0 = albedo;
    // float2 check = Checkerboard()
    if (SV_Target0.a < AlphaThreshold)
    {
        discard;
    }
    // emissivity in alpha channel
    // this zeros out the emissivity when the emissive intensity is 0
    SV_Target0.a *= Emissivity;
    // if (Tint.a != 0.0f)
    // {
    // const float4 p = MUL(ViewProjection, float4(input.WorldPosition, 1.0f));
    // output.Normal.rgb = p.xyz / p.w;
    // }
    // else
    // {
    // dumb normal encoding for dumb dummies; improve to use octahedron encoding or some cool thing
    SV_Target1 = vec4(normalize(xsv_TEXCOORD2.xyz) * 0.5f + vec3(0.5f), EncodeEmissive(EmissiveIntensity));
    // }
}
