// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec3  Position;
in vec3  Normal;
in vec2  TexCoord;
in uvec4 Bones;
in vec4  Weights;
out vec4 xsv_TEXCOORD0;
out vec4 xsv_COLOR0;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_12;
uniform vec4 vreg_13;
uniform vec4 vreg_14;
uniform mat3x4 vreg_15[64];


// Uniform name defines ///////////////////////////////////////
#define ModelToWorld vreg_0
#define WorldToView vreg_4
#define ViewToClip vreg_8
#define InverseModelScale_DepthClamp vreg_12
#define UTransform_ZBias vreg_13
#define VTransform vreg_14
#define Joints vreg_15
///////////////////////////////////////////////////////////////

void main()
{
    // matrix operations don't need mul macro for GLSL
    vec3 pos = (vec4(Position, 1.0f) * Joints[Bones.x]) * Weights.x + (vec4(Position, 1.0f) * Joints[Bones.y]) * Weights.y + (vec4(Position, 1.0f) * Joints[Bones.z]) * Weights.z + (vec4(Position, 1.0f) * Joints[Bones.w]) * Weights.w;
    vec4 wpos = ((vec4(pos, 1.0f)) * (ModelToWorld));
    vec4 cpos = ((wpos) * (WorldToView));
    gl_Position = ((cpos) * (ViewToClip));
    // this depth clamp exists so that we never miss shadow casters that are "closer" to the light than the scene is
    float min_depth = InverseModelScale_DepthClamp.w;
    gl_Position.z = max(min_depth, gl_Position.z);
    vec3 UTransform = UTransform_ZBias.xyz;
    xsv_TEXCOORD0.x = dot(UTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = dot(VTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = 1.0f - xsv_TEXCOORD0.y;
    xsv_TEXCOORD0.zw = TexCoord;
    xsv_COLOR0 = cpos;
    xsv_COLOR0.w = wpos.z;
}
