// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec3  Position;
in vec3  Normal;
in vec2  TexCoord;
in vec4  Color;
in uvec4 Bones;
in vec4  Weights;
out vec4 xsv_TEXCOORD0;
out vec3 xsv_TEXCOORD1;
out vec4 xsv_TEXCOORD2;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_13;
uniform vec4 vreg_14;
uniform mat3x4 vreg_15[64];


// Uniform name defines ///////////////////////////////////////
#define ModelToWorld vreg_0
#define WorldToView vreg_4
#define ViewToClip vreg_8
#define UTransform_ZBias vreg_13
#define VTransform vreg_14
#define Joints vreg_15
///////////////////////////////////////////////////////////////

void main()
{
    // matrix operations don't need mul macro for GLSL
    vec3 pos = (vec4(Position, 1.0f) * Joints[Bones.x]) * Weights.x + (vec4(Position, 1.0f) * Joints[Bones.y]) * Weights.y + (vec4(Position, 1.0f) * Joints[Bones.z]) * Weights.z + (vec4(Position, 1.0f) * Joints[Bones.w]) * Weights.w;
    vec4 wpos = ((vec4(pos, 1.0f)) * (ModelToWorld));
    vec4 cpos = ((wpos) * (WorldToView));
    gl_Position = ((cpos) * (ViewToClip));
    vec3 UTransform = UTransform_ZBias.xyz;
    xsv_TEXCOORD0.x = dot(UTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = dot(VTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = 1.0f - xsv_TEXCOORD0.y;
    xsv_TEXCOORD0.zw = TexCoord;
    // for the visual version we want to bias the depth toward the camera a bit
    // so that characters' feet aren't clipped by the floor
    float zbias = UTransform_ZBias.w;
    if (zbias != 0.0f)
    {
        vec4 biased_pos = cpos;
        biased_pos.z += zbias;
        float clip_z = dot(ViewToClip[2], biased_pos);
        float clip_w = dot(ViewToClip[3], biased_pos);
        float d = clip_z / clip_w;
        gl_Position.z = d * gl_Position.w;
    }
    xsv_TEXCOORD1 = wpos.xyz;
    // matrix operations don't need mul macro for GLSL
    vec3 n = (vec4(Normal, 0.0f) * Joints[Bones.x]) * Weights.x + (vec4(Normal, 0.0f) * Joints[Bones.y]) * Weights.y + (vec4(Normal, 0.0f) * Joints[Bones.z]) * Weights.z + (vec4(Normal, 0.0f) * Joints[Bones.w]) * Weights.w;
    xsv_TEXCOORD2.xyz = normalize(((vec4(n, 0.0f)) * (ModelToWorld)).xyz);
    xsv_TEXCOORD2.w = Color.a;
}
