// GLSL Vertex Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec3 Position;
in vec3 Normal;
in vec2 TexCoord;
in vec4 Color;
out vec4 xsv_TEXCOORD0;
out vec3 xsv_TEXCOORD1;
out vec4 xsv_TEXCOORD2;
uniform mat4 vreg_0;
uniform mat4 vreg_4;
uniform mat4 vreg_8;
uniform vec4 vreg_12;
uniform vec4 vreg_13;
uniform vec4 vreg_14;
uniform vec4 vreg_15;


// Uniform name defines ///////////////////////////////////////
#define ModelToWorld vreg_0
#define WorldToView vreg_4
#define ViewToClip vreg_8
#define InverseModelScale_DepthClamp vreg_12
#define UTransform_ZBias vreg_13
#define VTransform vreg_14
#define Animation vreg_15
///////////////////////////////////////////////////////////////

vec3 GenerateWaterMotion(vec3 pos, vec3 normal, float time, float amplitude, float speed)
{
    float phase = (pos.x + pos.y + pos.z) / 160.0f;
    float pi = 3.14159265f;
    vec2 freqs = vec2(1.414, 0.175);
    vec2 waves = pi * (fract(time * speed * freqs) * 2.0f - vec2(1.0f) + vec2(phase));
    vec2 motion = vec2(0.25f * amplitude, amplitude) * sin(waves);
    // const float3 new_pos = pos + (motion.x + motion.y) * normal;
    vec3 new_pos = pos + motion.y * normal;
    return new_pos;
}
void main()
{
    vec3 pos = Position;
    vec4 wpos = ((vec4(pos, 1.0f)) * (ModelToWorld));
    if (Animation.w == 1.0f)
    {
        wpos.xyz = GenerateWaterMotion(wpos.xyz, Normal, Animation.x, 160.0f * Animation.y, Animation.z);
    }
    vec4 cpos = ((wpos) * (WorldToView));
    gl_Position = ((cpos) * (ViewToClip));
    vec3 UTransform = UTransform_ZBias.xyz;
    xsv_TEXCOORD0.x = dot(UTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = dot(VTransform.xyz, vec3(TexCoord, 1.0f));
    xsv_TEXCOORD0.y = 1.0f - xsv_TEXCOORD0.y;
    xsv_TEXCOORD0.zw = TexCoord;
    // for the visual version we want to bias the depth toward the camera a bit
    // so that characters' feet aren't clipped by the floor
    float zbias = UTransform_ZBias.w;
    if (zbias != 0.0f)
    {
        vec4 biased_pos = cpos;
        biased_pos.z += zbias;
        float clip_z = dot(ViewToClip[2], biased_pos);
        float clip_w = dot(ViewToClip[3], biased_pos);
        float d = clip_z / clip_w;
        gl_Position.z = d * gl_Position.w;
    }
    xsv_TEXCOORD1 = wpos.xyz;
    vec3 is = InverseModelScale_DepthClamp.xyz;
    vec3 n = Normal.xyz * is;
    n = ((vec4(Normal.xyz, 0.0f)) * (ModelToWorld)).xyz;
    xsv_TEXCOORD2.xyz = normalize(n * is);
    xsv_TEXCOORD2.w = Color.a;
}
