// GLSL Fragment Shader "main"
// Generated by XShaderCompiler

#version 330 core
in vec2 xsv_TEXCOORD0;
out vec4 SV_Target0;
//  Simple shader for passing through an input texture with an alpha
//  blend value passed in as a shader constant.
//  Based on YCbCr for PS4, edited for SDL
uniform vec4 preg_0;
// (YUV Mode, unused, unused, unused)
uniform sampler2D treg_0;
uniform sampler2D treg_1;
uniform sampler2D treg_2;


// Uniform name defines ///////////////////////////////////////
#define SettingsA preg_0
#define TexY treg_0
#define TexU treg_1
#define TexV treg_2
///////////////////////////////////////////////////////////////

//  From SDL, for Kitchensink decode
//  YUV offset
vec3 offset709 = vec3(-0.0627451017, -0.501960814, -0.501960814);
//  RGB coefficients
vec3 Rcoeff709 = vec3(1.1644, 0.000, 1.7927);
vec3 Gcoeff709 = vec3(1.1644, -0.2132, -0.5329);
vec3 Bcoeff709 = vec3(1.1644, 2.1124, 0.000);
//  YUV offset
vec3 offset601 = vec3(-0.0627451017, -0.501960814, -0.501960814);
//  RGB coefficients
vec3 Rcoeff601 = vec3(1.1644, 0.000, 1.596);
vec3 Gcoeff601 = vec3(1.1644, -0.3918, -0.813);
vec3 Bcoeff601 = vec3(1.1644, 2.0172, 0.000);
//  Don't use ARBRect.
vec4 decodeYUV709(vec4 tc)
{
    vec3 yuv, rgb;
    vec4 xst_temp0 = (tc);
    yuv.x = textureLod(TexY, xst_temp0.xy, xst_temp0.w).r;
    vec4 xst_temp1 = (tc);
    yuv.y = textureLod(TexU, xst_temp1.xy, xst_temp1.w).r;
    vec4 xst_temp2 = (tc);
    yuv.z = textureLod(TexV, xst_temp2.xy, xst_temp2.w).r;
    // Do the color transform
    yuv += offset709;
    rgb.r = dot(yuv, Rcoeff709);
    rgb.g = dot(yuv, Gcoeff709);
    rgb.b = dot(yuv, Bcoeff709);
    return vec4(rgb, 1.0);
}
vec4 decodeYUV601(vec4 tc)
{
    vec3 yuv, rgb;
    vec4 xst_temp3 = (tc);
    yuv.x = textureLod(TexY, xst_temp3.xy, xst_temp3.w).r;
    vec4 xst_temp4 = (tc);
    yuv.y = textureLod(TexU, xst_temp4.xy, xst_temp4.w).r;
    vec4 xst_temp5 = (tc);
    yuv.z = textureLod(TexV, xst_temp5.xy, xst_temp5.w).r;
    // Do the color transform
    yuv += offset601;
    rgb.r = dot(yuv, Rcoeff601);
    rgb.g = dot(yuv, Gcoeff601);
    rgb.b = dot(yuv, Bcoeff601);
    return vec4(rgb, 1.0);
}
void main()
{
    vec4 t = vec4(xsv_TEXCOORD0, 0, 0);
    t.y = 1.0f - t.y;
    bool yuv709 = (SettingsA.x == 1.0f);
    vec4 xsr_output;
    if (yuv709)
    {
        xsr_output = decodeYUV709(t);
    }
    else
    {
        xsr_output = decodeYUV601(t);
    }
    SV_Target0 = xsr_output;
}
